#ifndef LIBCORE_H
#define LIBCORE_H

#include <libusb/usb_api.h>
#include <libhd/hd_api.h>

#ifdef __cplusplus
#define LIBCORE_API extern "C"	
#else
#define LIBCORE_API 
#endif

#ifndef NULL
#define NULL	(0)
#endif

#include "include/sdk_api.h"


#define MAX_IP_ADDRESS_LEN					(32)
#define IP_ADDRESS_LEN                      (16)

/// һͨõĶάӳ
typedef struct 
{
	unsigned int index;
	unsigned int value;
}common_map_t, *pcommon_map_t;

/// 붨
enum
{
	error_oops					= -1,
	error_ok					= 0,	
	error_invalid_parameters	= 65536,		// Чĺ
	error_unsupport	,							// ֵ֧Ľӿ
	error_callorder	,							// ˳ȷ
	error_username_used	,						// ûѾʹ
	error_login_failure	,						// ¼ʧ
	error_nodisk,								// ûӲ
	error_nothing_changed,						// ûиĶ
	error_filename,								// ļƲȷ
	error_invalidboard,							// Ƿİ
	error_based_version,						// 汾ȷ
	error_package_version,						// 汾ȷ
	error_read_file,							// дļзд
	error_bad_file,								// ָļڻ
	error_file_size,							// ļСȷ
	error_no_usbdisk,							// ǰϵͳûUSB豸(U,¼)
	error_new_disk,								// ʹõӲΪӲ(δʽ)
	error_no_channel_auth,						// ûͨȨ
	error_blocked,								// ֹIPַ.
};

/// һͨõļʽ,ļ·ڷ
typedef struct tagNode
{
	char szFilePath[255];
	char szPartitionName[32];
}T_FILE_NODE, *PT_FILE_NODE;

/// UϲǷָļƵļ,һļб
LIBCORE_API int core_system_get_file_location(char* filename, PT_FILE_NODE outFileList, unsigned int* outLanguageFileCnt);

/// ĳЩ÷仯ʱ֪ͨ
typedef enum 
{
	eStandardChanged,							// ϵͳʽ޸
	ePoweroffByRemote,							// Զ̹ػ
	eResumeChannelName							// ָͨΪĬ
}eWhichConfigChanged;

/// ϵͳ¼Դ
typedef enum
{
	eActionSource_Motion,						// ƶ
	eActionSource_Alarmin,						// 
	eActionSource_Videolost,					// Ƶʧ
	eActionSource_HDDFull,						// Ӳ
	eActionSource_HDDError,						// Ӳ̴
	eActionSource_NetBroken,					// ߶Ͽ
	eActionSource_Cover,						// ڵ
	eActionSource_NoHDD,						// Ӳ
	eActionSource_HDDFSError,
	eActionSource_HDDWriting,
	eActionSource_HDDFDOver,
	eActionSource_HDDAllError,
	eActionSource_Body,
}eActionSource;

//һ¼һ¼Ҫ¼˾úԺĻһ¼еĶ󶼱Ȼ
//жͲƥ󷵻أһvlostᵼԭֻmotionalarmĶ󶼱ѣӦ
typedef enum {
	eEventSourceType_Alarm		= 0x101,		// ϵͳ澯
	eEventSourceType_Vlost		= 0x201,		// Ƶʧ
	eEventSourceType_Motion		= 0x301,		// ƶ
	eEventSourceType_Cover		= 0x401,		// Ƶڵ
	eEventSourceType_Record		= 0x501,		// ¼
	eEventSourceType_Playback	= 0x601,		// ط
	eEventSourceType_HDD		= 0x701,		// Ӳ̴
	eEventSourceType_Network	= 0x801,		// 
	eEventSourceType_Backup		= 0x901,		// 
	eEventSourceType_Body		= 0xa01,		// 
	eEventSourceType_System		= 0x1001,		// ϵͳ
	eEventSourceType_CameraCruise = 0x1101,	// Ѳ¼
	eEventSourceType_Logo		= 0x1111,       //ʾ¼
	eEventSourceType_Pr    	= 0x10001,       //ͳʶ¼
	eEventSourceType_Park_ipc 	= 0x10002,       //λIPC¼
	/*add by wangmin, 2015-10-27 begin*/
#if 1
	eEventSourceCHType_Pr    	= 0x10011,   //ԶDVRͨż¼
	eEventSourceAdmittance_Pr	= 0x10012,	 //Զͨ׼Ȩ¼
#endif
	eEventSourceCHSer_Push		=0x10101,		//ķ
	/*add by wangmin, 2015-10-27 end*/
}eEventSourceType;

enum EVENT_PR_E
{
	EVENT_PR_INVALID = -1,
	EVENT_PR_IN =0,
	EVENT_PR_OUT=1,
};


/// ϵͳ¼,ӦeEventSourceType_System
enum EVENT_SYSTEM_E{
	EVENT_SYSTEM_INVALID = -1,
	EVENT_SYSTEM_STANDARD_CHANGE = 0,			// ϵͳʽ仯
	EVENT_SYSTEM_CHANNEL_MODE_CHANGE=1,			// ޸ͨģʽ,GUI¼,һ˴
	EVENT_SYSTEM_RESOLUTION_CHANGE, 			//ϵͳֱʸı
    EVENT_SYSTEM_UPDATE,                            //ϵͳ, netserver ֪ͨlibcore ͷԴĴ
    EVENT_SYSTEM_USER_LOGIN,
};

/// ¼,ӦeEventSourceType_Alarm
enum EVENT_ALARM_E{
	EVENT_ALARM_INVALID = -1,
	EVENT_ALARM_DISAPPEAR = 0,					// ¼
	EVENT_ALARM_ARISE,							// ¼
};

//motion¼
enum EVENT_MOTION_E{
	EVENT_MOTION_INVALID = -1,
	EVENT_MOTION_DISAPPEAR = 0,					// Ƶ¼
	EVENT_MOTION_ARISE,							// ............
};

enum EVENT_BODY_E{
	EVENT_BODY_INVALID = -1,
	EVENT_BODY_DISAPPEAR = 0,					// ¼
	EVENT_BODY_ARISE,							// ............
};

//video_lost¼
enum EVENT_VLOST_E{
	EVENT_VLOST_INVALID = -1,
	EVENT_VLOST_DISAPPEAR = 0,                  // Ƶʧ¼
	EVENT_VLOST_ARISE,							// ............
};

//video_cover¼
enum EVENT_COVER_E{
	EVENT_COVER_INVALID = -1,
	EVENT_COVER_DISAPPEAR = 0,					// Ƶڵ¼
	EVENT_COVER_ARISE,							// ............
};

//record
enum EVENT_RECORD_E{
	EVENT_RECORD_INVALID = -1,
	EVENT_RECORD_NONE = 0,										// δ¼
	EVENT_RECORD_NORMAL,										// ͨ¼
	EVENT_RECORD_MOTION,										// ƶ¼
	EVENT_RECORD_ALARM,											// ¼
	EVENT_RECORD_LOST,											// Ƶʧ¼(,δʹ)
	EVENT_RECORD_SIZE_ERROR,									// ƥ
	EVENT_RECORD_SIZE_RIGHT,                                    //ߴƥ
	EVENT_RECORD_VI_VARY,										//ģͨԴ仯
	EVENT_RECORD_IPCSIZE_MATCH, 								//IPCߴ粻ƥ
	EVENT_RECORD_AUXSIZE_CHANGE,								// ƥ
	EVENT_RECORD_FORCE_CHANGE_FILE,								//ǿлļ(ߴͬ)
	EVENT_RECORD_END,
};
//playback

enum EVENT_PLAYBACK_E{
	EVENT_PLAYBACK_INVALID = -1,
	EVENT_PLAYBACK_STOP = 0,									// طֹͣ
	EVENT_PLAYBACK_START,										// طſʼ
	EVENT_PLAYBACK_NO_RESOURCE,								//Դ
	EVENT_PLAYBACK_END,
};
//hdd

enum EVENT_HDD_E{
	EVENT_HDD_INVALID = -1,
	EVENT_HDD_NORMAL = 0,										// Ӳ
	EVENT_HDD_FORMATING,										// ڸʽӲ
	EVENT_HDD_NEED_FORMAT,										// ӲҪʽ
	EVENT_HDD_FS_RO,											// Ӳļϵͳ״̬Ϊֻ(Ҳһ쳣)
	EVENT_HDD_NOHDD,											// Ӳ
	EVENT_HDD_NOSPACE,											// ޿ռ
	EVENT_HDD_NEED_REPAIR,										// ӲҪ޸
	EVENT_HDD_END,

};


//net

enum EVENT_NET_E{
	EVENT_NET_INVALID = -1,
	EVENT_NET_LINKDOWN = 0,										// ӶϿ	
	EVENT_NET_LINKUP,											// 
	EVENT_NET_DHCPOK,											// DHCPȡIPַɹ
	EVENT_NET_DDNS_UPDATE,										// DDNS³ɹ,data1: upate time, time(NULL)
	EVENT_NET_REMOTE_CHANGE_CH_NAME,							// ͻ޸ͨ
	EVENT_NET_ADSL_CONNECTED,									// PPPOEκӳɹ
	EVENT_NET_CONFIG_MODIFY,									// ͻ޸
	EVENT_NET_USER_CONNECT_CHANGE,								// ͻӲ˱仯(½/˳)
	EVENT_NET_DEVICE_FOUND,										// һ豸(HVRͨ)
	EVENT_NET_CHANGE_CHANNEL_MODE,								// ͻ޸ͨģʽ,һɱUI¼(HVRͨ)
	EVENT_NET_USER_LOGIN,
	EVENT_NET_USER_LOGOUT,
	EVENT_NET_WIFI_CONNECTED,									// WIFIɹ.
	EVENT_NET_WIFI_DHCPOK,										// WIFIӿڵDHCPȡIPɹ.
	EVENT_NET_3G_CONNECTED,										// WIFIӿڵDHCPȡIPɹ.
	EVENT_NET_SCREEN_CONTROL,
	EVENT_NET_USER_UPGRADE,
	EVENT_NET_END,

};

//backup

enum EVENT_BACKUP_E{
	EVENT_BACKUP_INVALID = -1,
	EVENT_BACKUP_START = 0,										// ʼ
	EVENT_BACKUP_PROGRESS,										// ڱݹ(ˢ½)
	EVENT_BACKUP_END,											// ݽ
	EVENT_BACKUP_ERROR,											// ݹ̲(data1 ֵΪeBackupErrorType)

};
/// ݴ
enum eBackupErrorType
{
	ebet_ok,													// 
	ebet_nomore_space,											// ݹзû㹻ռ
	ebet_device_error,											// 豸ִ
};

enum EVENT_SERVERPUSH_E{
	EVENT_SERVERPUSH_INVALID = -1,
	EVENT_SERVERPUSH_LINK = 0,										//
	EVENT_SERVERPUSH_PUSH,											// 
};


#define day_per_week	(7)
#define hour_per_day	(24)
LIBCORE_API void 	core_show_version();
LIBCORE_API int		 core_initialize();							// ʼ,ϵͳеһӦõõĺ
LIBCORE_API int 		core_initialize_post();
LIBCORE_API int		 core_unitialize();							// ػǰ,ϵͳǰһЩβ
LIBCORE_API int		 core_board_get_board_id();					// ID
LIBCORE_API int      	core_board_get_device_type();				// 豸,hsx_device_type
LIBCORE_API const char* core_board_get_board_name();			// 	
LIBCORE_API unsigned core_board_get_video_total_cnt();			// Ƶͨ,ģ+ͨĿ֮ 
LIBCORE_API unsigned core_board_get_video_enc_cnt();			// ʾģͨ(ͨ)Ŀ
LIBCORE_API unsigned core_board_get_video_dec_cnt();			// ͨ
LIBCORE_API unsigned core_board_get_audio_enc_cnt();			// Ƶͨ
LIBCORE_API unsigned core_board_get_audio_dec_cnt();			// Ƶͨ
LIBCORE_API unsigned core_board_get_audio_talk_cnt();			// Խͨ
LIBCORE_API unsigned core_board_get_alarm_in_cnt();				// 
LIBCORE_API unsigned core_board_get_alarm_out_cnt();			// 
LIBCORE_API unsigned core_board_get_spot_cnt();					// 
LIBCORE_API unsigned core_board_get_enc_size();					// ȡǰߴб()
LIBCORE_API unsigned core_board_get_enc_performance();			// ȡǰ
LIBCORE_API unsigned core_board_is_reboot_when_stdchanged();	// ǰ޸ʽǷҪ豸
LIBCORE_API unsigned core_board_is_refresh_when_switch_uiport();// лUIʱǷҪˢUIλ
LIBCORE_API unsigned core_board_is_verify_license();			// ǷҪȨ
LIBCORE_API unsigned core_board_is_support_discdev();			// Ƿ֧Զֹ.
LIBCORE_API unsigned core_board_is_support_hvr_ch_state_logo();
LIBCORE_API unsigned core_board_is_support_showlogo_bysdk();	// ײǷֱ֧ʾͨLOGO(UIʾͼƬ)
LIBCORE_API unsigned core_board_is_support_lock_camera();		// Ƿ֧ͨ
LIBCORE_API unsigned core_is_enable_lock_camera();				// ǰϵͳǷͨ
LIBCORE_API int core_can_i_operate_channel(unsigned login_id, unsigned ch);		// ǰͨǷԲ
LIBCORE_API unsigned core_get_channel_mask(unsigned login_id);					// ȡûͨȨ
LIBCORE_API unsigned core_board_is_call_poweoff();				// Ƿֵ֧poweroff
LIBCORE_API unsigned core_board_get_ptz_ttyno();				// ȡ485ڵTTY
LIBCORE_API unsigned core_board_support_overlay_fb();			// Ƿֵ֧UI,֧־ҪرUI.
LIBCORE_API unsigned core_board_support_playback();
LIBCORE_API unsigned core_board_support_hdd();
LIBCORE_API unsigned core_board_support_buzzer();				// Ƿַ֧
LIBCORE_API unsigned core_board_support_gpio_key();                   //Ƿ֧gpio
LIBCORE_API unsigned core_board_support_carinfo();				// Ƿֳ֧ϢĻȡ
LIBCORE_API unsigned core_board_ipcresource_restric_type();		// ͨԴ䷽ʽ
LIBCORE_API unsigned core_board_ipcresource_restric_type();		// ͨԴ䷽ʽ
LIBCORE_API unsigned core_board_resume_default_way();				// ָĬ.
LIBCORE_API int  core_is_valid_ch(unsigned ch);


LIBCORE_API unsigned core_board_get_analog_cnt();				// ȡģͨ
LIBCORE_API unsigned core_board_get_ipcamera_cnt();				// ȡͨ(HVR)

LIBCORE_API char* core_board_retrieve_rwdir();					// ȡǰɶдҪļĿ¼,/mnt/mtd/app/
LIBCORE_API unsigned core_board_support_TDE();					// Ƿ֧˫,ʱӦӦVGACVBSӦ.

/// ϵͳ¼Ƶʵ,,˶,֪ͨ.
LIBCORE_API int core_register_event_handle(eEventSourceType type, char * name, int (* event_get_no_block)(int ch, int event, int data1, int data2));
LIBCORE_API int core_unregister_event_handle(eEventSourceType type, int (* event_get_no_block)(int ch, int event, int data1, int data2));
LIBCORE_API int core_event_put(eEventSourceType src_type,  int ch_idx, int event_type,int data1, int data2);

/// ֪ԭ,Ҫʹsystemϵͳ,ʹñӿ,ϵͳֲܻԤ֪ķ
LIBCORE_API int core_system_excute(char* cmd);

/// Ӳ
typedef struct 
{
	int overwrite_enable;							// ǷӲ̸
	
	int nodisk_speaker;
	int nodisk_showicon;

	int small_than_space_byGB_alarm;				// ӲСֵָʱʼ
	int nospace_speaker;
	int nospace_showicon;

	int hdderr_speaker;								// Ӳ̴,ļϵͳֻ״̬Լ,Ϊ,зĻʾ
	int hdderr_showicon;
	int email;										//ӲǷʼ
	int hdd_reserve_byday_enable;						//ðʱ䱣
	int hdd_reserve_maxday_rec;						//ౣ¼ļ
	int hd_workmode;								//Ӳ̹ģʽ1:Ӳ2:˫Ӳ
	char raid_arr_uuid[64];
	char device_uuid[2][64];
	int resvered[12];								// ֶ
}disk_config_t;

LIBCORE_API int core_system_disk_config_get(disk_config_t* config);
LIBCORE_API int core_system_disk_config_set(unsigned login_id, disk_config_t* config);

/// ʱ
typedef struct ntpc_config_s
{
	int enable;										// enable or disable internet time sync.(0,1)
	int interval;									// sync with internet time freq.(24*3600 - 7*24*3600)
	int timezone_hour;								// timezone(-12~13)
	int timezone_min;								// minute (0-59)

	char server[256];								// timer server(IPַ)

	int resevered[64];								// ֶ
}ntpc_config_t;	

LIBCORE_API int core_system_ntpc_config_get(ntpc_config_t* config);
LIBCORE_API int core_system_ntpc_config_set(unsigned login_id, ntpc_config_t* config);

///  ptz

#define max_protocol_name_len		(32)
#define max_protocol_cnt			(32)
typedef struct
{
	int  enable;									// ǷPTZ,Ǹͨ
	char protocol_name[max_protocol_name_len];		// Э(Pelco-P,Pelco-D)
	int bandrate;									// 
	int address;									// ַ(Э鱾)
	int speed;										// PTZ˶ٶ
}ptz_config_t, *pptz_config_t;

/// PTZЭ
typedef struct 
{
	char protocol_name[max_protocol_name_len];		// 
	char file_name[256];							// ļ(XML)
	unsigned max_preset_cnt;						// ֵ֧Ԥõ
	unsigned max_track_cnt;							// ֵ֧켣
	unsigned max_cruise_cnt;						// ֵ֧Ѳ

	unsigned max_assist_cnt;						// ָּ֧
}ptz_proto_info_t, *pptz_proto_info_t;

/// PTZ
typedef enum{
	PTZ_ACTION_BEGIN,
	PTZ_DIRECTION,									// 
	PTZ_ZOOM,										// 
	PTZ_FOCUS,										// 
	PTZ_IRIS,										// 
	PTZ_PRESET,										// Ԥõ
	PTZ_TRACK,										// 켣
	PTZ_CRUISE,										// Ѳ
	PTZ_ACTION_END,
	}ptz_action_e;


//
typedef enum
{
	PTZ_DIRCTION_UP,
	PTZ_DIRCTION_DOWN,
	PTZ_DIRCTION_LEFT,
	PTZ_DIRCTION_RIGHT,
	PTZ_DIRCTION_LEFT_UP,
	PTZ_DIRCTION_LEFT_DOWN,
	PTZ_DIRCTION_RIGHT_UP,
	PTZ_DIRCTION_RIGHT_DOWN,
	PTZ_DIRCTION_STOP,
	PTZ_DIRCTION_MENU,
	PTZ_DIRCTION_SET,	
}ptz_dirction_ctl_e;

//zoom
/// 
typedef enum
{
	PTZ_ZOOM_WIDE,					// Ŵ
	PTZ_ZOOM_TELE,					// С
	PTZ_ZOOM_STOP,
}ptz_zoom_ctl_e;

//focus
/// 
typedef enum
{
	PTZ_FOCUS_NEAR,					// (ĿŴ)
	PTZ_FOCUS_FAR,					// Զ(ĿС)
	PTZ_FOCUS_STOP,					// ͣ
}ptz_focus_ctl_e;

//iris
/// Ȧ
typedef enum
{
	PTZ_IRIS_OPEN,					// ȦŴ
	PTZ_IRIS_CLOSE,					// ȦС
	PTZ_IRIS_STOP,					// ͣ
}ptz_iris_ctl_e;

//preset
/// Ԥõ
typedef enum
{
	PTZ_PRESET_SET,					// Ԥõ
	PTZ_PRESET_CLR,					// Ԥõ
	PTZ_PRESET_GOTO,				// תԤõ
}ptz_preset_ctl_e;

//track
typedef enum
{
	PTZ_TRACK_START_SET,			// ʼ¼ƹ켣
	PTZ_TRACK_STOP_SET,				// ֹͣ¼ƹ켣
	PTZ_TRACK_RUN,					// й켣
}ptz_track_ctl_e;

//cruise
typedef enum
{
	PTZ_CRUISE_STOP,			// ֹͣѲ
	PTZ_CRUISE_START,				// ʼѲ
}ptz_cruise_ctl_e;

LIBCORE_API int core_ptz_dir_ctl(unsigned channel, ptz_dirction_ctl_e cmd);					//
LIBCORE_API int core_ptz_zoom_ctl(unsigned channel, ptz_zoom_ctl_e cmd);					//zoom
LIBCORE_API int core_ptz_focus_ctl(unsigned channel, ptz_focus_ctl_e cmd);					//focus
LIBCORE_API int core_ptz_iris_ctl(unsigned channel, ptz_iris_ctl_e cmd);					//iris
LIBCORE_API int core_ptz_preset_ctl(unsigned channel, ptz_preset_ctl_e cmd, int preset);	//preset
LIBCORE_API int core_ptz_track_ctl(unsigned channel, ptz_track_ctl_e cmd, int track);		//track

/// PTZͨ.
LIBCORE_API int core_ptz_set(unsigned login_id, unsigned channel, pptz_config_t config);
LIBCORE_API int core_ptz_get(unsigned channel, pptz_config_t config);
LIBCORE_API int core_set_ptz_type(unsigned login_id, unsigned channel, int type);
LIBCORE_API int core_get_ptz_type(unsigned channel);	
/// ȡǰֵ֧Э
LIBCORE_API int core_ptz_get_protocol(pptz_proto_info_t pproto_list, unsigned* list_cnt);

/// ݵ485˿,ûԶݵķ.
/// baudrateЧֵ:1200,2400,4800,9600
LIBCORE_API int core_ptz_485_data(int baudrate, char * buf, size_t len);
LIBCORE_API int core_ptz_485_data_yuheng(int baudrate, char * buf, size_t len);//only for yuheng
LIBCORE_API int core_ptz_485_set_baudrate(int baudrate);

//Ѳ
typedef struct
{
	int preset_indx;						//õԤõ
	int	stable_time_s;						//ʱ䣬Ϊλ
}c_point_info_t;

LIBCORE_API int core_ptz_cruise_rd_point(int ptz_idx, int cruise_indx, c_point_info_t *point, int buf_size, int *rel_num);
LIBCORE_API int core_ptz_del_cruise_ponit(int ptz_idx, int cruise_indx, int cruise_point_indx);
LIBCORE_API int core_ptz_cruise_rd_point_byindx(int ptz_idx, int cruise_indx, int point_indx, c_point_info_t *point);
LIBCORE_API int core_ptz_clear_cruise_ponit(int ptz_idx, int cruise_indx);
LIBCORE_API int core_ptz_set_cruise_ponit(int ptz_idx, int cruise_indx, int cruise_point_indx, int preset_indx, int time_s);
LIBCORE_API int core_ptz_add_cruise_ponit_head(int ptz_idx, int cruise_indx, int preset_indx, int time_s);
LIBCORE_API int core_ptz_add_cruise_ponit_tail(int ptz_idx, int cruise_indx, int preset_indx, int time_s);
LIBCORE_API int core_ptz_insert_cruise_ponit(int ptz_idx, int cruise_indx, int cruise_point_indx, int preset_indx, int time_s);
LIBCORE_API int core_ptz_save_cruise_ponit(int ptz_idx, int cruise_indx);
LIBCORE_API int core_ptz_reload_cruise_ponit(int ptz_idx, int cruise_indx);
LIBCORE_API int core_ptz_start_cruise(int ptz_idx);
LIBCORE_API int core_ptz_stop_cruise(int ptz_idx);
LIBCORE_API int core_ptz_cruise_status(int ptz_idx);
/// system

#define INVALID_LOGIN_ID		(0xFFFFFFFF)
#define INVALID_CHANNEL			(0xFFFFFFFF)

/// û
#define max_user_cnt			(10)
#define max_user_name_len		(32)
#define max_user_pwd_len		(32)
/// ϵͳȨ޶
typedef enum
{
	eAuthority_Configuration	= 0x01,		// 
	eAuthority_PTZControl		= 0x02,		// PTZ
	eAuthority_Playback			= 0x04,		// ط
	eAuthority_Backup			= 0x08,		// 
	eAuthority_ClearAlarm       = 0x16,		// (,δ)

	eAuthority_Undefined
}eAuthority;

/// ûϢ
typedef struct
{
	char name[max_user_name_len];			// û
	char password[max_user_pwd_len];		// 
	
	unsigned authority;						// ûȨ
	unsigned camera_authority;				// ûͨȨ
}user_info_t, *puser_info_t;

/// ¼
typedef enum 
{
	eLoginWay_local,						// UI
	eLoginWay_network,						// 
	eLoginWay_p2p,						// p2p

	eLoginWay_Undefined
}eLoginWay;

/// ¼Ϣ
typedef struct
{
	char name[max_user_name_len];			// û
	char password[max_user_pwd_len];		// 

	eLoginWay login_type;					// ¼
	unsigned  ip_address;					// ½ҪдIPַ
}login_info_t, *plogin_info_t;

/// AdminûûĻϢ
/// AdminûΪֻ
/// ˺UIƼʹ,Ҫڶͻ˵Ӧ.
typedef struct
{
	char admin_name[max_user_name_len];					// readonly
	char admin_password[max_user_pwd_len];				
	unsigned admin_authority;							// readonly(0xffffffff)
	unsigned admin_camauthority;						// readonly(0xffffffff)

	int user_cnt;										// û
	char name[max_user_cnt -1][max_user_name_len];
	char password[max_user_cnt -1][max_user_pwd_len];
	unsigned authority[max_user_cnt -1];
	unsigned camera_authority[max_user_cnt -1];
}users_info_t, *pusers_info_t;

/// ȡûûϢб
LIBCORE_API int core_user_retrieve_list(puser_info_t user_list, unsigned* list_cnt);
LIBCORE_API int core_user_retrieve(char* name, puser_info_t user);

/// ¼/ǳ
LIBCORE_API int core_user_login(plogin_info_t login_info, unsigned* login_id);
LIBCORE_API int core_user_logout(unsigned login_id);
LIBCORE_API int core_user_get_login_info(unsigned login_id, plogin_info_t login_info);

LIBCORE_API int core_user_retrieve_all_online_info( plogin_info_t list, const int list_cnt, int* client_cnt);

/// ûؽӿ,޸,,ɾ
LIBCORE_API int core_user_change_info(unsigned login_id, puser_info_t usre_info);
LIBCORE_API int core_user_add(unsigned login_id,puser_info_t usre_info);
LIBCORE_API int core_user_remove(unsigned login_id, puser_info_t usre_info);

/// һöû,һҪע,ڹԱû޸ıҪ֤ȷϷ
LIBCORE_API int core_users_set(unsigned login_id, pusers_info_t users_info);
LIBCORE_API int core_users_get(pusers_info_t users_info);

#define max_allowed_bw_cnt (32)
typedef struct ip_filter_s
{
	int enable;
	unsigned ip_list[max_allowed_bw_cnt];		// 0ʾЧIPַ,
	unsigned reserve[64];		// ,ԺҪչ
}ip_filter_t;
typedef struct black_while_list_s
{
	ip_filter_t black;
	ip_filter_t white;

	unsigned reserve[64];		// 
}black_white_list_t;
LIBCORE_API int core_black_white_list_set(unsigned login_id, black_white_list_t* bw_list);
LIBCORE_API int core_black_white_list_get(black_white_list_t* bw_list);

/// ϵͳ
#define max_device_name_len			(32)
#define max_time_format_string_len	(32)

/// 豸
typedef struct
{
	char name[max_device_name_len];				// 豸
	int language;								// (ϵͳֵ֧й)

	int time_format;							// ʱʽ
	unsigned device_id;							// 豸ID(,δ)

	int camera_mask_enable;						// ǷͨȨ

	int ip_camera_cnt;							// IPͨĿ

	float latitude;								// γ(GOOGLE MAPλ)
	float longitude;							// ھ

	char date_delimiter[4];						// ڷָ

	int camera_cruise_interval;					// ͨѲ֮ʱ
	int resume_after_camera_cruise_done;		// ͨѲ֮Ƿ񷵻ض໭(һ,UIƾ幤)
	int key_buzzer_enable;						//
	int zone_deviation;							//ʱƫ,ʱͬʱƫ
	int alarm_push;
	int mode_id;
	int reserver[58];

}basic_config_t, *pbasic_config_t;

LIBCORE_API int core_basic_config_set(unsigned login_id, pbasic_config_t pconfig);
LIBCORE_API int core_basic_config_get(pbasic_config_t pconfig);

/// ϵͳ߼
typedef struct
{
	int poweroff_delay_time_by_secnods;			// ʱػʱ,λ,

	int input_voltage_car_trigger;				// ʾѹ,ȡֵΧ[1,0].1,ߵƽ;0,͵ƽ
	int output_voltage_poweroff;				// ʾƹػĵѹ,ȡֵΧ[1,0].1,ߵƽ;0,͵ƽ

	int transparent;							// ͸
	int reserved[125];							// ֶ,Ժչ
}advan_config_t, *padvan_config_t;
LIBCORE_API int core_advan_config_set(unsigned login_id, padvan_config_t pconfig);
LIBCORE_API int core_advan_config_get(padvan_config_t pconfig);



/// 豸VGAؽӿ
LIBCORE_API int core_get_vga_support_list(const vga_res_info **res);					// ֵ֧ķֱб
LIBCORE_API int core_get_vga_cur_resolution(char * vga_resolution, unsigned len);		// ǰֱ
LIBCORE_API int core_get_vga_cur_resolution_id(unsigned* index);						// ǰֱʵID
LIBCORE_API int core_set_vga_mode(unsigned login_id, int mode_id, const vga_res_info *vga_res);		// ÷ֱ

/// ʱ
typedef struct 
{
	int tm_sec;     							/* seconds after the minute - [0,59] */
	int tm_min;     							/* minutes after the hour - [0,59] */
	int tm_hour;    							/* hours since midnight - [0,23] */
	
	int tm_mday;    							/* day of the month - [1,31] */
	int tm_mon;     							/* months since January - [0,11] */
	int tm_year;    							/* years since 1900 */
}dev_time_t, *pdev_time_t;

/// ʱζ
typedef struct
{
	dev_time_t begin;
	dev_time_t end;
}period_time_t, *pperiod_time_t;

// ʱʱṹ
typedef struct
{
	int tm_month;								// [0,11]
	int tm_week_index;							// [0-4]
	int tm_week_day;    						// [0-6]

	int tm_hour;								// [0-23]
	int tm_minute;								// [0-59]
	int tm_second;								// [0-59]
}dst_time_info;

LIBCORE_API int core_system_time_set(unsigned login_id, pdev_time_t);
LIBCORE_API int core_system_time_set_by_time_t(unsigned login_id, time_t ttCurTime);
LIBCORE_API int core_system_time_get(pdev_time_t);
/// ʱOSD,UI뱣֤ÿһ,Ӱ¼ʱOSD.
LIBCORE_API int core_system_update_timestamp (char * osd_param);

/// ʱ
typedef struct
{
	unsigned enable;							// Ƿʱ

	unsigned adjustment_by_seconds;				// ʱ䳤(ݵؾ,λ)
	dst_time_info begin;						// ʱʵʩڼ
	dst_time_info end;							// ʱʵʩڼֹ
}dst_config_t, *pdst_config_t;

LIBCORE_API int core_system_dst_get(pdst_config_t pconfig);
LIBCORE_API int core_system_dst_set(unsigned login_id, pdst_config_t pconfig);

/// ־
#define max_log_record_cnt		(10000)			// 56*10000 = 560*000 = 0.5MBڴ

/// ־
enum {
	LOG_MAIN_BEGIN, 

	LOG_MAIN_OPERATION	= 0x01,					// 
	LOG_MAIN_EXCEPTION	= 0x02,					// 쳣
	LOG_MAIN_ALARM		= 0x04,					// 澯

	LOG_MAIN_ALL		= 0xFFFFFFFF			// ȫ
};

/// ־Ͷ
enum {
	LOG_OPT_BEGIN			= 100,

	LOG_OPT_POWERON,							// 
	LOG_OPT_LOGOUT,								// ǳ
	LOG_OPT_LOGIN,								// ¼
	LOG_OPT_FORMAT_DISK,						// ʽӲ
	LOG_OPT_CLEAR_ALARM,						// 
	LOG_OPT_BACKUP,								// 
	LOG_OPT_UPDATE,								// 
	LOG_OPT_COMMON_CONFIG,						// ͨ	
	LOG_OPT_RESOLUTION_CONFIG,					// ޸ķֱ
	LOG_OPT_STANDARD_CONFIG,					// ʽ
	LOG_OPT_POLLING_CONFIG,						// Ѳ
	LOG_OPT_SCREEN_CONFIG,						// 
	LOG_OPT_AUDIO_MUTE,							// 
	LOG_OPT_AUDIO_VOLUME,						// 
	LOG_OPT_FACTORY_CONFIG,						// ָ
	LOG_OPT_USERINFO_CONFIG,					// ûϢ
	LOG_OPT_SYSTEMTIME_CONFIG,					// ϵͳʱ
	LOG_OPT_AUDIO_OUT_CONFIG,					// Ƶ
	LOG_OPT_START_RECORD,						// ʼ¼
	LOG_OPT_STOP_RECORD,						// ֹͣ¼
	LOG_OPT_CAMERA_NAME_CONFIG,					// ͨ
	LOG_OPT_RECORD_CONFIG,						// ¼
	LOG_OPT_COLOR_CONFIG,						// ɫ
	LOG_OPT_MOTION_CONFIG,						// ƶ
	LOG_OPT_MOSAIC_CONFIG,						// 
	LOG_OPT_VIDEOLOST_CONFIG,					// Ƶʧ
	LOG_OPT_PTZ_CONFIG,							// PTZ
	LOG_OPT_ALARM_CONFIG,						// 
	LOG_OPT_NETWORK_CONFIG,						// 
	LOG_OPT_DISK_CONFIG,						// Ӳ̹
	LOG_OPT_MAC_CONFIG,							// ַ(δʹ)
	LOG_OPT_NTP_CONFIG,							// NTP
	LOG_OPT_PWD_RESET,							// Admin
	LOG_OPT_COVER_CONFIG,						// ڵ
	LOG_OPT_BODY_CONFIG,						// 

	LOG_ALARM_BEGIN			= 200,
	LOG_ALARM_MOTION_START,						// ⵽ƶ¼
	LOG_ALARM_MOTION_STOP,						// ƶʧ
	LOG_ALARM_VIDEOLOST,						// ƵźŶʧ
	LOG_ALARM_VIDEOOK,							// ƵźŻָ
	LOG_ALARM_ALARMIN_TRIGGERED,				// 豸
	LOG_ALARM_ALARMOUT_TRIGGGERED,				// 豸
	LOG_ALARM_COVER_START,						// ⵽ڵ¼
	LOG_ALARM_COVER_STOP,						// ⵽ڵ¼
	LOG_ALARM_ALARMIN_STOP,					//źŶʧ
	LOG_ALARM_BODY_START,						// ⵽ڵ¼
	LOG_ALARM_BODY_STOP,						// ⵽ڵ¼

	LOG_EXCEPTION_BEGIN		= 300,
	LOG_EXCEPTION_HD_FULL,						// Ӳ
	LOG_EXCEPTION_HD_ERROR,						// Ӳ̴
	LOG_EXCEPTION_NET_BROKEN,					// ߶Ͽ
	LOG_EXCEPTION_NOHDD,						// Ӳ
	LOG_EXCEPTION_HD_FS,						// Ӳ̵ļϵͳ쳣
	LOG_EXCEPTION_HD_WRITTING,					// дӲ쳣
	LOG_EXCEPTION_HDALL_ERROR,					// Ӳ̶
	LOG_EXCEPTION_HD_FD_OVERFLOW,				// ӲԴй©
	LOG_AUTOADDIPC_ADDIPC,						//Զipc
	LOG_AUTOADDIPC_REMOVEIPC,						//Զɾipc
	LOG_SUB_ALL = 0xFFFFFFFF					// 
};

/// һ־ϸϢ
typedef struct
{
	time_t	 time_by_seconds;					// ־ʱ
	unsigned channel;							// ͨ
	unsigned main_type;							// 
	unsigned sub_type;							// 
	unsigned address;							// IPַ(0ʾ)
	char	 name[max_user_name_len];			// û
}log_node_t,*plog_node_t;

/// ־ѯʽ
typedef enum
{
	eLogQuery_NoStricted,

	eLogQuery_ByTime		= 0x01,				// ʱѯ
	eLogQuery_ByType		= 0x02,				// Ͳѯ
	eLogQuery_ByTimeAndType	= (eLogQuery_ByTime|eLogQuery_ByType),		// ʱ&Ͳѯ()

	eLogQuery_All			= 0xFFFFFFFF,		// ־()
}eLogQueryWay;

/// ־ѯص,֪ͨӦòжҳ־ʽȽϼʱ
typedef void(* cbf_finished_log_query)(unsigned qurey_id, unsigned page_cnt);
/// ־ѯ
typedef struct
{
	eLogQueryWay	way;						// ѯʽ
	dev_time_t	begin;							// ʼʱ(Ͳѯʱ)
	dev_time_t	end;							// ʱ(Ͳѯʱ)

	unsigned	channel;						// ͨ(0ʼ)

	unsigned	main_type;						// 
	unsigned	sub_type;						// 

	unsigned	record_per_page;				// ÿҳ־־

	cbf_finished_log_query	cbf;				// ص

	unsigned* query_id;							// һβѯID
}query_log_param, *pquery_log_param;

/// ־ز,ӣѯȡѯ,رһβѯ
LIBCORE_API int core_system_log_clear ();
LIBCORE_API int core_system_log_add (unsigned login_id, unsigned channel, unsigned main_type, unsigned sub_type);
LIBCORE_API int core_system_log_query(eLogQueryWay mode, unsigned channel,  unsigned main_type,unsigned sub_type, period_time_t * time, unsigned inPageItem, cbf_finished_log_query pQueryCB,  unsigned* handle);
LIBCORE_API int core_system_log_retrieve_page(unsigned query_id, plog_node_t log_list, unsigned list_cnt, unsigned page_no, unsigned* actual_cnt);
LIBCORE_API int core_system_log_enable_logquery_mask_tag();
LIBCORE_API int core_system_log_close(unsigned query_id);



/// ò
#define max_section_name_len		(32)
#define max_key_name_len			(32)
/// ļдӿ
LIBCORE_API int core_system_read_int(char* sec, char* key, int* value);						// ʽȡһֵ
LIBCORE_API int core_system_write_int(char* sec, char* key, int value);						// ʽдһֵ
LIBCORE_API int core_system_read_uint(char* sec, char* key, unsigned int* value);						// ʽȡһֵ
LIBCORE_API int core_system_write_uint(char* sec, char* key, unsigned int value);						// ʽдһֵ
LIBCORE_API int core_system_read_string(char* sec, char* key, char* string, unsigned len);	// ַʽȡһֵ
LIBCORE_API int core_system_write_string(char* sec, char* key, char* string, unsigned len);	// ַʽдһֵ
LIBCORE_API int core_resume_current_profile(int mode_id, int analog_ch_total, int ipcam_ch_total);


/// ļ(ںֻܶдڴУرһöʱҪUIеñ)
LIBCORE_API int core_system_save(unsigned login_id);										

#define CONST_MAX_DECODER_CHANNEL_NUM	16

/// ϵͳϢ
#define max_version_string_len		(32)
#define max_date_string_len			(32)

#define sysinfo_flag_software		(0x01)
#define sysinfo_flag_hardware		(0x02)
#define sysinfo_flag_language_cnt	(0x04)
#define sysinfo_flag_hdd_cap		(0x08)
#define sysinfo_flag_availabe_cap	(0x10)
#define sysinfo_flag_record_time	(0x20)

typedef struct
{
	unsigned flag;							// 0xffffffffʾȡȫֵ

	char software_version[max_version_string_len];			// ǰ汾
	char software_baseversion[max_version_string_len];		// ǰ汾
	char hardware_version[max_version_string_len];			// Ӳ汾
	char release_date[max_date_string_len];					// ־

	unsigned language_cnt;									// ǰϵͳֵ֧

	unsigned totoal_hdd_capacity;							// Ӳ
	unsigned total_available_capacity;						// Ӳ̿
	unsigned record_time_by_hour;							// Ӳ̿¼ĳʱ(ǰü㣬λСʱ)
}device_info_t, *pdevice_info_t; 

/// ȡ豸Ϣ
LIBCORE_API int core_system_deviceinfo(pdevice_info_t dev_info);


/// 

LIBCORE_API int core_system_upgrade(unsigned login_id );			/// δʵ
LIBCORE_API int core_system_reset_profile(unsigned login_id);		/// ָĬ



/// Ԥ
/// Ļʾ
typedef enum
{
	eSPT_VGA,						// VGA
	eSPT_TV,						// TV(CVBS)
	eSPT_Spot						// SPOT
}eScreenPortType;
/// Ԥ
typedef struct 
{
	int videoout_port;							// ǰƵĸ˿(0:HDMI,1,VGA,2,CVBS/TV)
	video_stand_e   videoout_standard;			// ǰϵͳʽ
}live_basic_config_t, *plive_basic_config_t;	

/// UIлӦĻʾ豸
/// port=0,HDMI
/// port=1,VGA
/// port=2,TV
LIBCORE_API int core_live_ui_set_port(unsigned login_id, int port);			
LIBCORE_API int core_live_ui_set_port_temp(unsigned login_id, int port);	// лUIĸʾ豸ʱã
LIBCORE_API int core_live_set_singal(unsigned login_id, video_stand_e standard);			// ϵͳʽ
LIBCORE_API int core_live_set_singal_and_reboot(unsigned login_id, video_stand_e standard);	// ϵͳʽϵͳ
LIBCORE_API int core_live_get_basic_cfg(plive_basic_config_t config);		// ȡԤ(0:HDMI,1,VGA,2,CVBS/TV)
LIBCORE_API int core_live_get_vo_if(int* port);								// ȡUIʾ豸(0:HDMI,1,VGA,2,CVBS/TV)
LIBCORE_API int core_live_get_vo_if_temp(int* port);						// ȡǰʱUI豸(0:HDMI,1,VGA,2,CVBS/TV)
//LIBCORE_API int core_live_all_video_on(unsigned start_ch, unsigned ch_cnt, div_rect_t * div_rect, video_out_dev_e port);	// ָƵʾ
LIBCORE_API int core_live_all_video_off();									// رƵʾ
// LIBCORE_API int core_live_clear_logo(video_out_dev_e vo_dev);				// ָĻʾϵLOGO(ͼ꣬ƷLOGO)
// LIBCORE_API int core_live_show_logo(vo_rect_t *vo_rect, int num);			// ʾLOGO

LIBCORE_API int core_framebuffer_size_get(video_out_dev_e vo_dev, video_stand_e std, int *width, int *height);

/// Ƶ
LIBCORE_API int core_live_volume_get(unsigned* volume);						
LIBCORE_API int core_live_volume_set(unsigned login_id, unsigned volume);	// volume(0-15)
LIBCORE_API int core_live_audio_ismute(unsigned* enable);
LIBCORE_API int core_live_audio_mute(unsigned login_id, unsigned enable);	// 
LIBCORE_API int core_live_get_audioout_ch(int * channel);					// ǰĸͨƵ
LIBCORE_API int core_live_set_audioout_ch(unsigned login_id, int channel);	// ĸͨƵ(ڻȡ)
LIBCORE_API int core_live_audio_on(int channel, int flag);					// ĳͨ


/// Ԥѯ
typedef struct
{
	int	enable;					// Ƿ
	int			port;			// ѯĻ豸(0:HDMI,1,VGA,2,CVBS/TV)
	int			interval;		// ѯʱ(λ)
	int			view_cnt;		// ,Ļ,,Ż
}polling_config_t, *ppolling_config_t;

LIBCORE_API int core_live_polling_config_set(unsigned login_id, ppolling_config_t config);
LIBCORE_API int core_live_polling_config_get(ppolling_config_t config);

/// Ļ(һʹTVʾĳ)
LIBCORE_API int core_live_screen_position_set(unsigned login_id, video_out_dev_e vo_port, div_rect_t* config);
LIBCORE_API int core_live_screen_position_get(video_out_dev_e vo_port, div_rect_t* config);
LIBCORE_API int core_live_screen_position_default(unsigned login_id, video_out_dev_e which_one);// ָĬĻλ

typedef enum
{
	 RECORD_TYPE_INVALID = 0,			//Ƿ¼,¼,Ԥ¼
	 RECORD_TYPE_TIME	 = 0x01 << 0,	//ʱ¼
	 RECORD_TYPE_MOTION	 = 0x01 << 1,	//ƶ¼
	 RECORD_TYPE_ALARM	 = 0x01 << 2,	//¼
	 RECORD_TYPE_MANUAL	 = 0x01 << 3,	//ֶ¼
	 RECORD_TYPE_COVER	 = 0x01 << 4,	//ڵ¼
	 RECORD_TYPE_STOP    = 0x01 << 5,   //û¼ҲûԤ¼
	 RECORD_TYPE_AM		 = 6 ,		//¼¼(ڱ¼ƻ,¼ҲܸĶֵ)
	 RECORD_TYPE_ALL	 = 0xFFFFFFFF,
}record_type_e;


/// ͨ
typedef struct 
{
	int bright;			// 
	int hue;			// ɫ
	int contrast;		// Աȶ
	int saturation;		// Ͷ
	int sharpness;		// 

	/// Чʱ
	int enable_second_config;		// Ƿõڶɫò
	int valid_begin_hour;
	int valid_begin_min;
	int valid_end_hour;
	int valid_end_min;

	int second_bright;			// ڶ
	int second_hue;				// ڶɫ
	int second_contrast;		// ڶԱȶ
	int second_saturation;		// ڶͶ
	int second_sharpness;		// ڶ

	int  ircut;
	int  ae;				//ع

	int second_ircut;
	int ae_time;          //عʱ
	int ae_gain;          //
	int ae_iris;	//Ȧ
	int reserve[16];	
}color_config_t, *pcolor_config_t;

LIBCORE_API int core_camera_set_color(unsigned login_id, unsigned channel, pcolor_config_t config);
LIBCORE_API int core_camera_get_color(unsigned channel, pcolor_config_t config);

/// ͨĻ(HVR)
/*
typedef struct
{
	int enable;					// ǰͨǷѾ.
	int is_ipcam;				// ǰͨǱͨIPCAMͨ.
	int ipcam_port;				// IPCAM˿.
	int ipcam_channel;			// IPCAMͨ,һΪ0.
	int ipcam_resolution;		// IPCAMıֱ

	char ipcam_ipaddr[MAX_IP_ADDRESS_LEN];			// IPCAMIPַ.
	char ipcam_username[max_user_name_len];			// ½IPCAMû
	char ipcam_password[max_user_name_len];			// ...........

	eIPC_Type  ipcam_type;		// IPC
}camera_attr_t, *pcamera_attr_t;*/
typedef struct
{
	int 	enable;					// ǰͨǷѾ.
	int 	is_ipcam;				// ǰͨǱͨIPCAMͨ.
	int 	is_auto_add;				//IPCӷʽ 0ֶ1Զ
	nc_channel_config_t	config;
}camera_attr_t, *pcamera_attr_t;

#define MAX_IPC_NODLISTNUM   128
/// ͨĻ(HVR)
typedef struct
{
	int enable;					// ǰͨǷѾ.
	int is_ipcam;				// ǰͨǱͨIPCAMͨ.
	int ipcam_port;				// IPCAM˿.
	int ipcam_channel;			// IPCAMͨ,һΪ0.
	int ipcam_resolution;		// IPCAMıֱ
	int ch;					//豸ͨ(ĿǰֻgkЭ)
	int support_protocol;                            //Э
	char ipcam_ipaddr[IP_ADDRESS_LEN];			// IPCAMIPַ.  192.xxx.xxx.xxx
	char private_ipaddr[IP_ADDRESS_LEN];			// ˽еIPַ.	10.xxx.xxx.xxx
	char ipcam_username[max_user_name_len];			// ½IPCAMû
	char ipcam_password[max_user_name_len];			// ...........

	eDevice_Type ipcam_type;		// IPC
}camera_new_attr_t, *pcamera_new_attr_t;

typedef struct
{
	int add_type;   //IPCӷʽ 0ֶ1Զ
	char private_ip[MAX_IP_ADDRESS_LEN];//˽IPַ
	int reserve[128];
}camera_ex_attr_t, *pcamera_ex_attr_t;
LIBCORE_API int core_camera_get_attr(unsigned channel, pcamera_attr_t config);
LIBCORE_API int core_camera_set_attr(unsigned login_id, unsigned channel, pcamera_attr_t config);

LIBCORE_API int core_camera_get_attr_ex(unsigned channel, pcamera_new_attr_t config);
LIBCORE_API int core_camera_set_attr_ex(unsigned login_id, unsigned channel, pcamera_new_attr_t config);
LIBCORE_API int  core_camera_set_autoaddipc_enable(unsigned login_id,  int enable);
LIBCORE_API int  core_camera_get_autoaddipc_enable(int *enable);
LIBCORE_API int  core_camera_get_attr_ex_ex(unsigned channel, pcamera_ex_attr_t config);
LIBCORE_API int  core_camera_set_attr_ex_ex(unsigned login_id, unsigned channel, pcamera_ex_attr_t config);

LIBCORE_API int  core_camera_get_enc_support(unsigned login_id, unsigned channel, hvr_support_enc_size_t * support_enc);

LIBCORE_API int  core_get_decoder_type(unsigned channel, decoder_type_e *decoder_type);
LIBCORE_API int  core_set_decoder_type(unsigned channel, decoder_type_e decoder_type);

/// ֮Ҫô˺ʹͨЧ.
LIBCORE_API int core_camera_invalid_ipc(unsigned login_id);	

#define max_camera_cnt		(32)
#define max_alarmout_cnt	(32)
/// Ͷ
typedef enum 
{
	ePTZActType_Preset,			// Ԥõ
	ePTZActType_Track,			// 켣
	ePTZActType_Cruise,			// Ѳ

	ePTZActType_Undefined
}ePTZActType;

/// ϸϢ(ĸͨĸ,4ͨĵ2Ԥõ)
typedef struct
{
	unsigned channel;			// ͨ
	unsigned id;				// 
}ptz_action_node_t;
/// PTZб
typedef struct
{
	unsigned act_cnt;							// м
	ptz_action_node_t node[max_camera_cnt];		// б(Ѳ켣ݲ֧)
}ptz_action_t;

/// ¼
typedef struct
{
	int record_en;								// Ƿ֧¼
	int alarmout_en;							// Ƿֱ֧
	int preset_en;  							// Ƿ֧Ԥõ
	int track_en;								// Ƿֹ֧켣
	int cruise_en;								// Ƿ֧Ѳ
	
	int speaker_en; 							// Ƿַ֧
	int mail_en;								// Ƿ֧ʼ
	int fullscreen_en;							// Ƿֵ֧Ŵ(ȫ)
	
}action_enable_t;

/// 
typedef struct
{
	int record;						// λΪʾ,Ϊһʾ¼
	int alarmout;					// λΪʾ,Ϊһʾ
	int preset;						// λΪʾ,Ϊһʾ(һԤõ)
	int track;						// λΪʾ,Ϊһʾ(һŹ켣),δʹ
	int cruise;						// λΪʾ,Ϊһʾ(һѲ),δʹ

	int speaker;					// 
	int mail;						// ʼ
	int fullscreen;					// ȫ

	/// йͨѲֶκftpϴͼƬ.
	unsigned channel_cruise_mask;	// ͨѲ,ÿһλʾӦͨǷѲ.
	int upload_pic_by_ftp;			// ǷͨFTPͼƬϴFTP.

	int preset_index[32];			// Ԥõ,preset_index[0]ʾ0ͨpreset_index[0]Ԥõ,
	int track_index[32];			// 켣,track_index[0]ʾ0ͨtrack_index[0]Ԥõ,
	int cruise_index[32];			// Ѳ,cruise_index[0]ʾ0ͨcruise_index[0]Ԥõ,

	unsigned reserve[64];			// һЩֶιԺչ.
}action_config_t, *paction_config_t;

/// Ƶʧ
typedef struct
{
	int enable;						// ǷƵʧ

	action_config_t action;			// 

	int schedule[day_per_week][hour_per_day];					// Ƶʧƻ.Ĭȫ첼
	int delay_by_second;
	int showicon;					// Ƿʾͼ. 
	int reserver[64];				// 
}videolost_config_t, *pvideolost_config_t;

LIBCORE_API int core_camera_videolost_set(unsigned login_id, unsigned channel, pvideolost_config_t config);
LIBCORE_API int core_camera_videolost_get(unsigned channel, pvideolost_config_t config);



/// ƶ

#define max_motion_rect_column	(16)
#define max_motion_rect_row		(12)
typedef struct
{
	unsigned enable;					// Ƿƶ

	unsigned precision;					// ⾫

	char area[max_motion_rect_row][max_motion_rect_column];		// ֵ1ʾ

	action_config_t action;				// 
	int delay_by_second;
	int schedule[day_per_week][hour_per_day];					// ƶⲼƻ.Ĭȫ첼
	int showicon;						// ƶͼǷʾ.
	int start_x;
	int start_y;
	int end_x;
	int end_y;
	int vga_w;
	int vga_h;
	int reserver[58];					// .
}motion_config_t, *pmotion_config_t;

LIBCORE_API int core_camera_motion_set(unsigned login_id, unsigned channel,  pmotion_config_t config);
LIBCORE_API int core_camera_motion_get(unsigned channel, pmotion_config_t config);

typedef struct
{
	unsigned enable;					// Ƿƶ
	action_config_t action;				// 
	int delay_by_second;
	int schedule[day_per_week][hour_per_day];					// ƶⲼƻ.Ĭȫ첼
	int showicon;						// ƶͼǷʾ.
	int reserver[16];					// .
}body_config_t, *pbody_config_t;
LIBCORE_API int core_camera_body_set(unsigned login_id, unsigned channel,  pbody_config_t config);
LIBCORE_API int core_camera_body_get(unsigned channel, pbody_config_t config);

/// Ƶڵ
typedef struct 
{
	unsigned enable;							// ǷƵڵ,ĬϹر
	unsigned precision;							// ⾫,,û.
	unsigned delay_by_second;					// ʱ.
	int schedule[day_per_week][hour_per_day];	// ƻ.

	action_config_t action;						// .
	int showicon;
	int reserver[64];							// ,ԱԺչ
}cover_config_t, *pcover_config_t;

LIBCORE_API int core_camera_cover_set(unsigned login_id, unsigned channel, pcover_config_t config);
LIBCORE_API int core_camera_cover_get(unsigned channel, pcover_config_t config);

/// ζ
typedef struct
{
	long    left;			// 
	long    top;			// 
	long    right;			// 
	long    bottom;			// 
}rect_t, *prect_t;

/// ڸ(,mosaic)
#define max_mosaic_area_cnt		(4)
typedef struct
{
	unsigned enable;		// 

	unsigned area_cnt;		// 
	rect_t area[max_mosaic_area_cnt];		// б
}mosaic_config_t, *pmosaic_config_t;

LIBCORE_API int core_camera_mosaic_set(unsigned login_id, unsigned channel, pmosaic_config_t config);
LIBCORE_API int core_camera_mosaic_get(unsigned channel, pmosaic_config_t config);

/// OSD 
#define max_camera_name_len		(32)
typedef struct 
{
	char name[max_camera_name_len];			// ͨ

	unsigned left;							// (Ϊwidth_scaleλ,λ,ʵʵʾͼֱʽе)
	unsigned top;							// (߶Ϊheight_scaleλ,λ,ʵʵʾͼֱʽе)
	
	unsigned osd_time_left;					// (߶Ϊwidth_scaleλ,λ,ʵʵʾͼֱʽе)
	unsigned osd_time_top;					// (Ϊheight_scaleλ,λ,ʵʵʾͼֱʽе)

	unsigned width_scale;					
	unsigned height_scale;
	int reserve[62];
}osd_config_t, *posd_config_t;
/// libcoreⱾûֿ,ҪṩOSDַϢ
LIBCORE_API void core_camera_register_get_string_bitmap(int (*get_string_bitmap)(char *in_string, char *out_buf, int out_buf_size, int * width, int * height));
LIBCORE_API int core_camera_osd_get(unsigned channel, posd_config_t config);
LIBCORE_API int core_camera_osd_set(unsigned login_id, unsigned channel, posd_config_t config);


#define max_alarmin_cnt	(32)
/// 볣̬
typedef enum
{
	eNormalStatus_Closed,			// 
	eNormalStatus_Open,				// 

	eNOrmalStatus_Undefined
}eNormalStatus;
// ״̬
typedef enum
{
	eArmingStatus_Disable,			// 
	eArmingStatus_Enable,			// 

	eArmingStatus_Undefined
}eArmingStatus;
/// ״̬
typedef enum
{
	eAlarmStatus_Idle,				// ״̬
	eAlarmStatus_Triggered,			// ()

	eAlarmStatus_Undefined
}eAlarmStatus;
/// 
typedef struct
{
	eNormalStatus type;				// ̬
	eArmingStatus schedule[day_per_week][hour_per_day];		// ʱ

	action_config_t action;			// 

	int delay_by_seconds;			// ʱʱ
	int showicon;					// Ƿʾͼ.

	int reserve[32];				// 
}alarmin_config_t, *palarmin_config_t;

LIBCORE_API int core_alarmin_set(unsigned login_id, unsigned channel, palarmin_config_t config);
LIBCORE_API int core_alarmin_get(unsigned channel, palarmin_config_t config);
LIBCORE_API int core_alarmin_get_status(unsigned channel);


/// 
typedef struct 
{
	int enable;											// Ƿ
	
	char name[max_user_name_len];						// 

	eArmingStatus schedule[day_per_week][hour_per_day];	// ƻ
	
	int auto_reset_time;								// Զλʱ
}alarmout_config_t, *palarmout_config_t;
/// һӿھ,δʹ.״̬֪ͨȡ¼ȡ.ؽӿ.
LIBCORE_API int core_alarmout_set(unsigned login_id, palarmout_config_t config);
LIBCORE_API int core_alarmout_get(palarmout_config_t config);
LIBCORE_API int core_alarmout_get_status(unsigned channel);


/// ¼ϸϢ
typedef struct
{
	int				dst_ch;		//Ӧͨ(ao_0,ao_1)

	eActionSource 	src_type;	//¼Դ(motion,alarmin)
	int 			src_ch;		//¼Դĸͨ
	time_t			time;		//ʱ
}event_action_state;


LIBCORE_API int core_clear_alarm(unsigned login_id);										// 
LIBCORE_API int core_get_soundout_sourcelist(event_action_state* list, unsigned* list_cnt);	// е
LIBCORE_API int core_get_alarmout_sourcelist(event_action_state* list, unsigned* list_cnt);	// еı

/// 
typedef struct 
{
	int delay_time;		// ֮ʱ
	eArmingStatus schedule[day_per_week][hour_per_day];		// ʱ(δ)
}buzzer_config_t, *pbuzzer_config_t;

/// ¼񲿷
/// ¼Ͷ
typedef enum
{
	eRecordSourceType_VideoOnly,		// Ƶ
	eRecordSourceType_VideoAudio,		// Ƶ+Ƶ

	eRecordSourceType_Undefined
}eRecordSourceType;

/// ¼
typedef struct
{
	int bitrate;						// 
	int framerate;						// ֡
	int resolution;						// ֱ
}record_quality_t, *precord_quality_t;

/// ¼
typedef struct
{
	eRecordSourceType type;					// 

	record_quality_t quality;				// 
	
	record_quality_t event_quality;			// ¼¼ʱ

	int is_manaul;							// Ƿֶ¼
	record_type_e schedule[day_per_week][hour_per_day];		// ¼ƻ

	int pre_rec_time;						// Ԥ¼ʱ(READONLY)
	int delay_rec_time;						// ӳ¼ʱ(READONLY)
}record_config_t, *precord_config_t;


LIBCORE_API int core_record_config_set(unsigned login_id, unsigned channel, precord_config_t config);
LIBCORE_API int core_record_config_get(unsigned channel, precord_config_t config);
LIBCORE_API int core_sync_config_set(unsigned login_id, unsigned channel, int synchronization_config);
LIBCORE_API int core_sync_config_get(unsigned channel, int *synchronization_config);
LIBCORE_API int core_record_start_bymanual(unsigned login_id, unsigned channel);		// ʼֶ¼
LIBCORE_API int core_record_stop_bymanual(unsigned login_id, unsigned channel);
LIBCORE_API record_type_e core_record_get_status(unsigned channel);						// ȡ¼״̬
LIBCORE_API int core_realtime_stream_info(unsigned channel, venc_str_e str_id, enc_str_info_t *info);
LIBCORE_API int core_ipc_realtime_stream_info(unsigned channel, ipc_enc_para_t *info);

/// 粿
typedef struct pppoe_config_s{
	int enable;						// ǷPPPOEκ
	char username[32];				// û
	char password[32];				// 
}pppoe_config_t;

/// PPPOEϢ
typedef struct pppoe_info_s{
	int status;						// Ƿ
	int ip;							// IP
	int submask;					// 
	int gateway;					// 
}pppoe_info_t;

/// DDDNS
typedef struct ddns_config_s{
	int enable;						// Ƿ̬ͻ
	char username[32];				// û
	char password[32];				// 
	char domain_name[64];			// 
	int 	protocol_index;			// ʹõЭ飨֧DDNS
}ddns_config_t;

#define DDNS_PROTOCOL_COUNT_MAX		32
/// DDNSЭб
typedef struct ddns_protocols_s{
	int count;									// Э
	char name[DDNS_PROTOCOL_COUNT_MAX][64];		// Э
	char server[DDNS_PROTOCOL_COUNT_MAX][32];	// 
}ddns_protocols_t;

typedef struct ftp_config_s
{
	int enable;				// Ƿftp

	char server[64];		// FTPַ
	int  port;				// FTP˿.
	char username[32];		// û
	char password[32];		// 
	int  is_anonymous;		// Ƿ
	char remote_path[128];	// ԶĿ¼

	int reserve[64];		// 
}ftp_config_t, *pftp_config_t;



LIBCORE_API int core_network_ftp_set(unsigned login_id, ftp_config_t* config);
LIBCORE_API int core_network_ftp_get(ftp_config_t* config);


typedef struct rs485_config_s
{
	char server[64];		// ַ
	int  port;				// ˿.
}rs485_config_t, *prs485_config_t;

LIBCORE_API int core_network_rs485_set(unsigned login_id, rs485_config_t* config);
LIBCORE_API int core_network_rs485_get(rs485_config_t* config);

#define EMAIL_TO_ADDRESS_CNT_MAX			3
#define EMAIL_ADDRESS_LEN_MAX				64	
#define EMAIL_QUEUE_LEN_MAX				32
#define EMAIL_ATTACH_FILE_MAX				10
#define EMAIL_TITLE_LEN_MAX					128
#define EMAIL_CONTENT_LEN_MAX				512
#define EMAIL_CAPIMAGE_MAX					1
/// ʼ
typedef struct email_config_s{
	int enable;									// Ƿ֧ʼ

	int 	ssl_enable;							// TLS/SSL
	int  	port;								// ʼ˿
	char server[64];							// ַ
	char username[32];							// û
	char password[32];							// 
	char from_addr[64];							// ַ
	char to_addr[EMAIL_TO_ADDRESS_CNT_MAX][64];	// Ŀַ
	int  need_snapshot;							// ǷҪнͼΪ͸澯ʼ
}email_config_t;
/// ϸϢ
typedef struct email_content_s
{
	char  title[EMAIL_TITLE_LEN_MAX];			// ʼ
	char  content[EMAIL_CONTENT_LEN_MAX];		// ʼ
	char  attach_file_name[256];				// ļȫ·
}email_content_t;

/// 
typedef struct 
{
	int enable;									// Ƿ
	int framerate_by_fps;						// ֡
	int bitrate_by_kbps;						// 
}subcode_t, *psubcode_t;

/// 
typedef struct network_config_s
{
	//ip
	int ip;							// ̬IPַ
	int submask;					// 
	int gateway;					// 
	int dns1;						// DNS
	int dns2;						// DNS

	//port
	int http_port;					// WEB˿(Ĭ80)
	int cmd_port;					// ˿
	int data_port;					// ýݼ˿
	int mobile_port;				// ֻ˿

	//upnp
	int upnp_enable;				// ǷUPNP,Զ򿪶˿ӳ䣬Ҫ·UPNPܡ

	//dhcp
	int dhcp_enable;				// ǷҪ̬ȡ

	//pppoe
	pppoe_config_t pppoe_config;	// PPPOE

	//ddns
	ddns_config_t ddns_config;		// DDNS

	//email
	email_config_t email_config;	// ʼ

	//subcode
	subcode_t	subcode_config;		// 
}network_config_t;

/// Ϣ
typedef struct network_info_s
{
	//mac
	char mac[32];					// ַ
	//pppoe				
	pppoe_info_t pppoe_info;		// PPPOEκŻϢ

}network_info_t;

typedef struct network_info_ptop_s
{
	int p2p_enable;
	char reserve[128]; //ֶ
}network_info_ptop_t;
	
/// 󶨱豸Ϣ(δʹ)
typedef struct master_info_s
{
	time_t bind_time;			// ʱ
	unsigned ip_address;		// IPַ
}master_info_t;
/// ޸֮Ҫ֪ͨUIӦĽ洦˻صUIṩ
typedef void (*cbf_notifapp_if_cfgchanged_by_net)(eWhichConfigChanged type, int param2, int pram3, int pram4);
LIBCORE_API int core_network_set_cfgchanged_notify_cbf(cbf_notifapp_if_cfgchanged_by_net cbf);
LIBCORE_API int core_network_config_set(unsigned login_id, network_config_t * config);		// 
LIBCORE_API int core_network_config_get(network_config_t * config);
LIBCORE_API int core_network_info_get(network_info_t * info);								// ȡϢ
LIBCORE_API int core_network_ddns_protocols(ddns_protocols_t * protocols);
//P2P
LIBCORE_API int core_network_ptop_get(network_info_ptop_t * config);
LIBCORE_API int core_network_ptop_set(unsigned login_id, network_info_ptop_t * config);
LIBCORE_API int core_get_merge_capability(int item);
LIBCORE_API int core_get_merge_state(void);

/// ʼɱUIṩֻUIַ,ΪԵĲͬ
typedef void (* cbf_mail_content_from_gui) (int event_type, int channel, char* title, char* body);
LIBCORE_API int core_network_set_mail_content_cbf(cbf_mail_content_from_gui cbf);
/// ʼ
LIBCORE_API int core_network_test_config( char *to_addr,
										  char* smtp_server,		
										  short smtp_port,
										  int   tls_enable,
										  char* username, 
										  char* password, 
										  char* from_address, 
										  char* mail_title,	
										  char* mail_content,	
										  char* attach_file_name);
/// ַ(δʹ)
LIBCORE_API int core_network_set_mac_address(unsigned login_id, char* mac_addr);
LIBCORE_API int core_network_get_bindinfo(master_info_t* info);// ȡϢ(δʹ)


//playback
/// طͨʾλ
typedef struct
{
	int ch;					//ͨ
	div_rect_t div_rect;	//ʾ
}playback_dis_ctl_t;

typedef struct
{
	int ch_indx;//ͨ
	search_file_list_head_t *main_flist_head;//ļ
	search_file_list_head_t *aux_flist_head;//ļ
	int enable_double_str;//Ƿ˫ط
	char  reserve[64];
}pb_file_cfg_t;

LIBCORE_API int core_pb_set_win(unsigned int login_id, const playback_dis_ctl_t *dis_ctl, int ctl_num);		//ʾ
LIBCORE_API int core_pb_set_file(unsigned int login_id, int ch, search_file_list_head_t *file_list_head);	//ûطŵļ
LIBCORE_API int core_pb_set_double_str_file(unsigned int login_id,pb_file_cfg_t pb_file);	//ûطŵļԴļ
LIBCORE_API int core_pb_start(unsigned int login_id, time_t tstart);		// ָʱ俪ʼط
LIBCORE_API int core_pb_exit(unsigned int login_id);						// ֹͣط

LIBCORE_API time_t core_pb_get_time(unsigned int login_id);					// ȡǰĻطʱ
LIBCORE_API int core_pb_seek_time(unsigned int login_id, time_t time);		// طŶλ

LIBCORE_API int core_pb_start_aplay(unsigned int login_id, int ch);			// 򿪻ط
LIBCORE_API int core_pb_stop_aplay(unsigned int login_id);					// ֹͣط

LIBCORE_API int core_pb_pause(unsigned int login_id, int pause);					// ͣط
LIBCORE_API int core_pb_set_speed(unsigned int login_id, play_speed_e speed);		// ûطٶ
LIBCORE_API int core_pb_step(unsigned int login_id);								// ֡ط

LIBCORE_API int core_pb_event_pos_set_date(period_time_t range);					// ûȡһʱε¼
LIBCORE_API int core_pb_event_pos_cnt();											// õʱε¼
LIBCORE_API int core_pb_next_event_pos(unsigned login_id, time_t cur_time, time_t* next_time);	// ȡһ¼λ

//ȡǰϵͳеUSB豸
LIBCORE_API int core_get_usb_info(unsigned int login_id, hsx_usb_dev_info_t *info, size_t info_num, int *dev_num);

//backup
/// ļʽ,bk_devΪ豸,bk_partΪ豸ķ
/// 豸,żlibusb.hͷļڶ
LIBCORE_API int core_backup_start(unsigned int login_id, search_file_list_head_t *file_list[], int list_num, int bk_dev, int bk_part, time_t start, time_t stop);
LIBCORE_API int core_start_back_up(unsigned int login_id, search_file_list_head_t *file_list[], int list_num, int bk_dev, int bk_part, time_t start, time_t stop, back_type_e  back_type, int back_count);

LIBCORE_API int core_backup_exit(unsigned int login_id);

//fdisk
/// ʽӲ
LIBCORE_API int core_format_disk(unsigned int login_id, int disk_idx, fmt_call_back func);
/// ޸Ӳ
LIBCORE_API int core_repair_disk();
//update
/// 
typedef struct
{
	char fname[128];				// ļ
}update_file_attr_t;

/// ״̬
typedef enum
{
	DVR_UPDATE_STAT_START = 0,		/* ʼ */
	DVR_UPDATE_STAT_STOP = 1,		/*  */
	DVR_UPDATE_STAT_PROGRESS = 2,	/* ֪ͨ */
}update_state_e;

typedef int	(*update_call_back)(update_state_e status, int retval, int percent);

/// ɨUSB豸еļȡб
LIBCORE_API int core_update_scan_file(unsigned int login_id, const char *directory, update_file_attr_t *flist, size_t flist_num, int *real_num);
LIBCORE_API int core_update_start(unsigned int login_id, const char *fname, update_call_back func);		// ʼ


/// Զ豸(HVR)
#define max_support_remote_dev_cnt			(10)
typedef struct 
{
	char ip_address[MAX_IP_ADDRESS_LEN];		// Զ豸IPַ
	unsigned cmd_port;							// Զ豸ʹõĶ˿

	char username[max_user_name_len];			// ½Զ豸ʱʹõû
	char password[max_user_pwd_len];			//                     
}remote_dev_info_t;

typedef struct
{
	/// ǰԶ豸
	unsigned int remote_dev_cnt;				

	/// Զ豸ľϢ
	remote_dev_info_t remote_dev_list[max_support_remote_dev_cnt];
}remote_dev_config_t;

LIBCORE_API int core_remote_dev_config_get(remote_dev_config_t* config);
LIBCORE_API int core_remote_dev_config_set(unsigned int login_id, remote_dev_config_t* config);


/// Զ豸(HVR)
typedef struct
{
	unsigned int allow_discover_me_by_others;			// Ƿƽ̨豸ҵ

	/// ˿ʱ,ڴ˴
	/// DVR豸,չ㲥ͽ豸ϢĶ˿ù̶,ʹ,͸
	unsigned short response_port_as_device;				// receive broadcast packet from discover(CMS or other)
	unsigned short response_port_as_discover;			// receive udp message with device information from device

	unsigned int reserved[64];							// 	
}discover_config_t;

LIBCORE_API int core_discover_dev_config_get(discover_config_t* config);
LIBCORE_API int core_discover_dev_config_set(unsigned login_id, discover_config_t* config);

/// ɨڵDVRIPC豸
LIBCORE_API int core_discover_dev_scan();//ʼ
LIBCORE_API int core_discover_dev_scan_ex();

LIBCORE_API int core_discover_dev_stop();//ֹͣ

/// Ѿɨ赽豸
LIBCORE_API int core_discover_dev_clear();
LIBCORE_API int core_discover_dev_clear_ex();

/// ȡǰɨԶ豸
LIBCORE_API int core_retrieve_remote_device(device_info_node* list, const int list_cnt, int * how_many_list_cnt);
LIBCORE_API int core_retrieve_remote_device_ex( device_info_node* list, const int list_cnt, int * how_many_list_cnt );

//ڴ棬gui㱨Ϣʾkey:/mnt/mtd/app/hsx_ddns_client
/// ԴĻϢ

typedef struct
{

	int magic;					// 0x12344321

	char domain_name[64];		// 

	time_t last_update_time;		// һɹˢipʱ䣬ʱΪ0

	//½Ϣ
	char domain_name_ML[64];
	time_t last_update_time_ML; //һγɹˢipʱ䣬ʱΪ0

	char reserved[256 - 64 - sizeof(time_t)];

}hsx_ddns_shmem_cmd;

/// ȡǰ豸ԴĻ
LIBCORE_API int core_retrieve_mobile_eye_ddnsinfo(hsx_ddns_shmem_cmd* ddns_info);

/// SDKAPIӿڷװ
LIBCORE_API int	core_buzzer(int buzzer_ms);
LIBCORE_API int core_set_led(keyboard_led_e led, int state);	
LIBCORE_API int core_cfg_vpre(int dvr_ch, vo_rect_t *vo_rect, int rect_num);
LIBCORE_API int core_apply_vpre();
LIBCORE_API int	core_stop_vpre(video_out_dev_e vo_dev, int ch_mask);
//LOGObg_colorΪRGB888ʽıɫߴ糬352*288ԶüС352*288ԶУ㲿bg_color
//bitʽΪRGB1888, һռ32bitalpha: bit31-24R: bit23-16G: bit15-8B: bit7-0
//alphaΪ0ʾbg_colorʾ
LIBCORE_API int core_set_logo_bit(logo_type_e logo_type,  int *bit, int bit_w, int bit_h, int bg_color);
LIBCORE_API int	core_dis_logo(vo_rect_t *vo_rect, int rect_num);
LIBCORE_API int	core_clr_logo(video_out_dev_e vo_dev);
LIBCORE_API int core_stop_play_rect(video_out_dev_e vo_dev, int ch_mask);
LIBCORE_API const hvr_channel_info_t* core_get_ch_info(int hvr_ch);	
LIBCORE_API int core_adj_screen(div_rect_t *adj_rect, video_out_dev_e vo_dev);
LIBCORE_API int core_reboot();	
LIBCORE_API int core_do_update();
LIBCORE_API int core_disable_dog();	
LIBCORE_API int core_power_off();	
LIBCORE_API int	core_set_logo(const char *fname, logo_type_e logo);
LIBCORE_API video_out_dev_state core_get_vo_state(video_out_dev_e vo);	

/// HDӿڷװ
LIBCORE_API int core_hd_get_total_disk_cnt();
LIBCORE_API int core_hd_get_disk_info(int index, disk_into_t *diskinfo);
LIBCORE_API search_file_list_node_t*	core_hd_file_search_get_first_node(search_file_list_head_t *head);
LIBCORE_API search_file_list_node_t*	core_hd_file_search_get_next_node(search_file_list_head_t *head);
LIBCORE_API unsigned int				core_hd_get_month_record_info(unsigned int year, unsigned int month);
LIBCORE_API search_file_list_head_t*	core_hd_file_search(time_t day, int rec_type, int ch, int need_uncomplete);
LIBCORE_API search_file_list_head_t*	core_hd_new_file_search(rec_search_s search_info);
LIBCORE_API int		core_hd_file_search_list_free(search_file_list_head_t *head);
LIBCORE_API int 	core_hd_file_search_get_node_status(search_file_list_node_t* node);
LIBCORE_API int 	core_hd_file_search_set_node_status(search_file_list_node_t* node, int status);
LIBCORE_API int 	core_hd_file_search_get_node_file_size(search_file_list_node_t* node);
LIBCORE_API int		core_hdd_get_status(eActionSource action_source);
/// USBӿڷװ
LIBCORE_API int core_usb_get_dev_info(int idx, hsx_usb_dev_info_t *info);

LIBCORE_API int core_get_passed_info();

typedef enum {
	eAuthorizationResult_Fail,
	eAuthorizationResult_OK,
	eAuthorizationResult_Invalid,
}eAuthorizationResult;
LIBCORE_API eAuthorizationResult core_is_authorized_success( void );

// typedef enum
// {
// 	HIGH_IS_FOR_NIGHT = 0, //ߵѹʾ
// 	HIGH_IS_FOR_DAY = 1, //ߵѹʾ
// }icr_polarity;
// 
// typedef enum
// {
// 	IPC_AE_INDOOR_MODE = 0, //ģʽ
// 	IPC_AE_OUTDOOR_MODE = 1, //ģʽ
// }ipc_ae_work_mode;
/*/*/
// int sdkapi_ipc_set_icr_level(icr_polarity polarity, int high_level, int low_level);
// int sdkapi_ipc_set_ae_para(ipc_ae_work_mode mode, int day_para, int night_para);
// int sdkapi_ipc_set_mode(ipc_ae_work_mode mode);
// int sdkapi_ipc_set_ae_freq(int freq);
//
/// IPCԶ
typedef struct 
{
	unsigned exposure_in_day;		// ֵ,Χ[0-99]
	unsigned exposure_in_night;		// ҹֵ,Χ[0-99]

	unsigned reserved[8];			// 
}exposure_config_t;

typedef struct
{
	ipc_ae_work_mode work_mode;				// ģʽ.,
	exposure_config_t config_indoor;		// ڲ
	exposure_config_t config_outdoor;		// 
	unsigned freq;							// ԴƵ
	
	char fixed_mode_start_hour;			// 0-23,default 18
	char fixed_mode_start_mini;			// 0-59,default 0
	char fixed_mode_end_hour;			// 0-23,default 21
	char fixed_mode_end_min;			// 0-59,default 0
	unsigned fixed_mode;				// ǿΪģʽ

	unsigned resevered[14];				// Աչ
}auto_exposure_confg_t;

LIBCORE_API unsigned core_system_autoexposure_config_get(auto_exposure_confg_t* config);
LIBCORE_API unsigned core_system_autoexposure_config_set(unsigned login_id, auto_exposure_confg_t* config);

/// ƽ
typedef struct
{
	icr_polarity polarity;
	unsigned high_level;
	unsigned low_level;
}icr_config_t;

LIBCORE_API int core_live_set_pre_roi(int dvr_ch, div_rect_t *roi_rect);
LIBCORE_API int core_live_cancel_pre_roi(int dvr_ch);

LIBCORE_API int core_pb_set_play_roi(int play_ch, div_rect_t *roi_rect);
LIBCORE_API int core_pb_cancel_play_roi(int play_ch);




/// йONVIF,:
/// profiles, Ŀǰ֧,ֱ
/// videosource_config, Ŀǰ֧һ.ҹ̶.

/// PROFIEL
typedef struct
{
	char name[max_key_name_len];
	char token[max_key_name_len];
	char vidoe_source_config[max_key_name_len];
	char video_encoder_config[max_key_name_len];
	char audio_source_config[max_key_name_len];
	char audio_encoder_config[max_key_name_len];
	char video_analytic_config[max_key_name_len];
	char ptz_config[max_key_name_len];
	char metadata_config[max_key_name_len];
}profile_t, *pprofile_t;

/// VIDEO_SOURCE_CONFIG
typedef struct
{
	char name[max_key_name_len];
	char token[max_key_name_len];
	char source_token[max_key_name_len];
	int bound_x;
	int bound_y;
	int bound_width;
	int bound_height;
}video_source_config_t, *pvideo_source_config_t;

/// AUDIO_SOURCE_CONFIG
typedef struct
{
	char name[max_key_name_len];
	int use_count;
	char token[max_key_name_len];
	char source_token[max_key_name_len];
}audio_source_config, *paudio_source_config;

/// AUDIO_ENCODER_CONFIG
typedef struct
{
	char name[max_key_name_len];
	int use_count;
	char token[max_key_name_len];
	int encoding;
	int bitrate;
	int samplerate;

	/// ಥ
	char multicast_address_ipv4[max_key_name_len];
	char multicast_address_ipv6[max_key_name_len];
	int  multicast_port;
	int  multicast_ttl;
	int  multicast_autostart;

	int session_timeout;
}audio_encoder_t,*paudio_encoder_t;

/// VIDEO_ENCODER_CONFIG
typedef struct
{
	char name[max_key_name_len];
	int use_count;
	char token[max_key_name_len];
	int encoding;
	
	int resolution_width;
	int resolution_height;

	char quality[max_key_name_len];	// Ϊfloat,ʵʹõʱҪתһ.

	int ratecontrol_frameratelimit;			// ֡
	int ratecontrol_encodinginterval;		// ֡
	int ratecontrol_bitratelimit;			// 

	int codec_type;							// mpeg4h264
	/// mepg4,
	int mpeg4_govlength;
	int mpeg4_profile;

	/// h264ı,
	int h264_govlength;
	int h264_profile;
}video_encoder_config_t, *pvideo_encoder_config_t;

/// ༭ƵԴ
LIBCORE_API unsigned core_ovf_videosrc_cfg_get(video_source_config_t *cfg, unsigned *cfg_num);
LIBCORE_API unsigned core_ovf_videosrc_cfg_set(video_source_config_t *cfg, unsigned *cfg_num);

/// ༭ƵԴ
LIBCORE_API unsigned core_ovf_audiosrc_cfg_get(audio_source_config *cfg, unsigned *cfg_num);
LIBCORE_API unsigned core_ovf_audiosrc_cfg_set(audio_source_config *cfg, unsigned *cfg_num);

/// ༭Ƶ
LIBCORE_API unsigned core_ovf_videoenc_cfg_get(video_encoder_config_t *cfg, unsigned *cfg_num);
LIBCORE_API unsigned core_ovf_videoenc_cfg_set(video_encoder_config_t *cfg, unsigned *cfg_num);

/// ༭ӱ
LIBCORE_API unsigned core_ovf_audioenc_cfg_get(audio_encoder_t *cfg, unsigned *cfg_num);
LIBCORE_API unsigned core_ovf_audioenc_cfg_set(audio_encoder_t *cfg, unsigned *cfg_num);

/// ༭PROFILE
LIBCORE_API unsigned core_ovf_profile_get(profile_t *cfg, unsigned *cfg_num);
LIBCORE_API unsigned core_ovf_profile_set(profile_t *cfg, unsigned *cfg_num);


///  ع
// typedef struct
// {
// 	char longitude_WE;	//ascַWʾEʾ
// 	unsigned char longitude_d;	//
// 	unsigned char longitude_m;	//
// 	unsigned char longitude_s;	//
// 
// 	char latitude_NS;	//ascַNʾγSʾγ
// 	unsigned char latitude_d;	//
// 	unsigned char latitude_m;	//
// 	unsigned char latitude_s;	//
// 
// 	//ٶȣm/s ,ȷСλ
// 	char x_axis_i;	//xٶ(bit7Ϊ0ʾΪ1ʾbit0-bit6ʾֵ)
// 	unsigned char x_axis_f;	//xٶС
// 
// 	char y_axis_i;	//ٶ(bit7Ϊ0ʾΪ1ʾbit0-bit6ʾֵ)
// 	unsigned char y_axis_f;	//ٶС
// 
// 	char z_axis_i;	//ٶ(bit7Ϊ0ʾΪ1ʾbit0-bit6ʾֵ)
// 	unsigned char z_axis_f;	//ٶС
// 
// 	char reserverd[18];
// }car_gps_info;


/// ȡǰĳϢ
LIBCORE_API int core_system_get_cur_car_info(car_gps_info *info);
/// ȡĳһʱ̵ĳϢ
LIBCORE_API int core_system_get_his_car_info(time_t time, car_gps_info *info);

/// ʼ¼Ϣ,һϵͳӲ̸ʽ֮.
LIBCORE_API int core_system_start_save_car_info();
/// ֹͣ¼Ϣ,һϵͳرջӲ̸ʽ֮ǰ.
LIBCORE_API int core_system_stop_save_car_info();


/// Էָģʽ
/// ϵͳݴʾͨλ.
typedef struct screen_display_config_s
{
	int mode;					// ָģʽ,,4,6,8,9.ֵΪ0ʾʹĬ
	int page;					// ڼҳ
	int bigone_index;			// ָģʽд󵥻,д.

	int reserve[64];			// Ժչ
}screen_display_config_t;
LIBCORE_API int core_live_screen_display_config_get(screen_display_config_t* config);
LIBCORE_API int core_live_screen_display_config_set(unsigned login_id, screen_display_config_t* config);

/// WIFIӿ
/// wifi

// ȫ
typedef enum{
	eSecurityType_Begin		= 0,
	eSecurityType_WEP		= 1,
	eSecurityType_WPA		= 2,	
	eSecurityType_WPA2		= 4,
	eSecurityType_WPAPSK	= 8,
	eSecurityType_WPA2PSK	= 16
}eSecurityType;

/// ȫѡ
typedef enum
{
	eSecurityOption_Begin  = 0,
	eSecurityOption_Shared = 1,
	eSecurityOption_Open   = 2,
}eSecurityOption;

/// 㷨
typedef enum 
{
	eEncrypType_NONE		= 0,
	eEncrypType_AES			= 1,
	eEncrypType_TKIP		= 2,
	eEncrypType_CCMP		= 4,
	eEncrypType_PSK			= 8,
}eEncrypType;

typedef enum
{
	eNetworkType_Unknown    = 0,
	eNetworkType_Infra		= 1,
	eNetworkType_Adhoc		= 2,
}eNetworkType;

typedef struct wifi_config_s{
	//wifi
	int  enable;
	eSecurityType security_type;		// ȫ
	eSecurityOption security_opt;		// ȫѡ
	eEncrypType  encryptype;			// 㷨
	char ssid[32];
	char pass[32];
	int  enable_dhcp;		//wifi˿Ƿʹdhcp
	unsigned ip;			//ʹdhcp
	unsigned submask;		//ʹdhcp
	unsigned gw;			//ʹdhcp
	unsigned dns1;			//ʹdhcp
	unsigned dns2;			//ʹdhcp
	
	int reserve[64];
}wifi_config_t;

/// wifiǰ״̬
typedef struct wifi_status_s{
	//wifi
	char ssid[32];
	int connect_status;		//Ƿ
	unsigned ip;
	unsigned submask;
	unsigned gw;
	unsigned dns1;
	unsigned dns2;
	
	unsigned reserve[64];
}wifi_status_t;

/// WIFIϢ.
typedef struct wifi_encrypt_s
{
	eSecurityType type;
	eEncrypType   group_cipher;
	eEncrypType   pairwise_cipher;
	eEncrypType   auth_suites;

	//  ,ݱ
	char name[32];
	char Group_Cipher[32];				// 
	char Pairwise_Ciphers[32];			// 
	char Authentication_Suites[32];		// ֤
}wifi_encrypt_t;

typedef struct wifi_quality_s
{
	int now;
	int max;				
	int signal_level;
	int noise_level;
}wifi_quality_t;

typedef struct wifi_point_s
{
	char			ssid[32];				// SSID
	char			mac[32];				// mac address
	char			protocol[32];			// protocol
	char			mode[32];				// mode
	int				encryption;

	wifi_quality_t	quality;				// źǿȣ0-100 0  100ǿ
	float			freq;					// Ƶ
	int				channel;				// ͨ
	unsigned		bitrate;				// 
	int				support_encryption_cnt;	// ֵּ֧¼ʽ,֧5¼ʽ
	wifi_encrypt_t* encrypt_list;			// 㷨

	int				resever[32];
}wifi_point_t;

/// ɨ赽WIFI.Ŀǰ֧ǰ100.
typedef struct wifi_network_list_s{

	long			count;						// ҵwifi
	int				reserve2[64];				// Աչ

	wifi_point_t*	list;				// б׸ַ
}wifi_network_list_t;
LIBCORE_API wifi_network_list_t* core_network_wifi_hotpot_list();
LIBCORE_API int core_network_wifi_config_set(unsigned login_id, wifi_config_t* config);
LIBCORE_API int core_network_wifi_config_get(wifi_config_t* config);
LIBCORE_API int core_network_wifi_status(wifi_status_t* status);

//added by xiaoyi for upnp
LIBCORE_API int core_network_upnp_map(unsigned int port, const char* protocol);
LIBCORE_API int core_network_upnp_unmap(unsigned int port, const char* protocol);
LIBCORE_API int core_network_upnp_apply();

/// 3G
/// 
typedef enum provider_type_s
{
	G3_AUTO,
	G3_TD_SCDMA,
	G3_WCDMA, // йͨ
	G3_CDMA_1x, // й
	G3_GPRS,// йƶ
	G3_EVDO
}provider_type_t;

typedef struct g3_network_config_s
{
	int enable;						// Ƿ,1,,0,.
	provider_type_t provider_type;	// Ӫ̷
	char dial_number[32];			// .
	char username[32];				// û
	char password[32];				// 
	
	char apn[32];					// APN
	int reserved[120];				// . 
}g3_network_config_t;

/// ״̬
typedef struct g3_network_status_s
{
	int status;						// Ƿ
	int ip;							// IP
	int submask;					// 
	int gateway;					// 
	int sig_quality;				//ź
	char factory[32];				//
	char model[32];                               //ģʽ
	char carrieroperator[64];               //Ӫ
	int reserved[95];				// . 
}g3_network_status_t;

LIBCORE_API int core_network_3g_config_set(unsigned login_id, g3_network_config_t* config);
LIBCORE_API int core_network_3g_config_get(g3_network_config_t* config);
LIBCORE_API int core_network_3g_get_status(g3_network_status_t* status);

//IPC½ӿ

//ЭͻȡЭ
int 	core_get_specify_protocol(int ipc_ch, int protocol, protocol_t **p);

//ȡ֧Эб
int  core_get_all_protocol(int ipc_ch, protocol_t **p, int *size);

//ȡ豸ֵ֧Э
//key_word:豸ؼ
//pProtocol:豸ֵ֧Э
int core_get_support_protocol(char *key_word, type_protocol_map_t** description);	

//ȡض豸ضЭµ
//type:豸
//protocol:豸Э
//
int core_get_capability(int ipc_ch, int type, int protocol, device_capability **pCapability);

//޸豸ipַ
//interfaceToken:ӿƣeth0
//type:ӿ:ipv4 or ipv6
int core_modify_ipaddress(int ipc_ch, char *interfaceToken, int type, int dhcp, int ipaddr, int submask, int gateway, int dns1, int dns2);
int core_modify_ipaddress_ex(int protocol,int type,char* host,int port,char* username,char* password,netInfo net_info);
int core_obtain_ipaddress_ex(int protocol,int type,char* host,int port,char* username,char* password,netInfo* net_info);

//ircutģʽ
//ircut:0-ɫ,1-ڰ,2-Զ
int core_set_ircut(int ipc_ch, int ircut);

//عģʽ
//aemode:عģʽ,0-Զ,1-ֶ
//time:عʱ,ֶعʱ
int core_set_aemode(int ipc_ch, int aemode, int time);

typedef struct BPS_control_config_s
{
	int screen_mode;
	int bps_type;
	int reserved[32];				// . 	
}BPS_control_config_t;

/******************************************************************
name: core_pap_rect_config_get(int channel,pap_rect_config_t rect);
	  core_pap_rect_config_set(unsigned login_id,int channel, pap_rect_config_t rect);
function: papýб棬½Իԭ
author: zyd
date: 2014.5.22
******************************************************************/
#define max_pap_num			(5)
#define one_pap_rect_num			(8)
#define max_pap_rect_num			(40)
typedef struct pap_rect_config_s
{
	div_rect_t  pap_rect[max_pap_num];
	char reserved[32];				// . 		
}pap_rect_config_t;

LIBCORE_API int core_pap_rect_config_get(int channel,pap_rect_config_t *config);
LIBCORE_API int core_pap_rect_config_set(unsigned login_id,int channel, pap_rect_config_t *config);


LIBCORE_API int core_bps_control_config_set(unsigned login_id, unsigned channel , BPS_control_config_t* config);
LIBCORE_API int core_bps_control_config_get(unsigned channel, BPS_control_config_t* config);
LIBCORE_API int core_set_pre_pip(int channel, div_rect_t* pip_rect);
LIBCORE_API int core_cancel_pre_pip(int channel);
LIBCORE_API int core_start_pre_pap(int channel, int pap_idx, div_rect_t * src_rect);
LIBCORE_API int core_cancel_pre_pap_rect(int channel);
LIBCORE_API int core_set_pre_pap_rect(int channel, int pap_num, div_rect_t * pap_rect);
LIBCORE_API int core_prepare_play_snapshot();
LIBCORE_API int core_set_play_snapshot_rect(int play_ch, int snapshot_num, div_rect_t * rect);
LIBCORE_API int core_play_snapshot(int play_ch, search_file_list_head_t * play_file, time_t start_time, time_t end_time,
								 int snapshot_num, snapshot_file_t * file_info, int max_file_cnt);
LIBCORE_API int core_exit_play_snapshot();
LIBCORE_API int core_divide_vpre();
LIBCORE_API int core_get_gpio_key_info(int *key_id, char *key_name);

LIBCORE_API int  core_get_cur_encsize(int channel);//ȡǰͨƵԴߴ


/******************************************************
LIBCORE_API int core_set_alarm_push(unsigned login_id,int push_mask)
ýӿ
int push_mask bitλӵ͵λeEventSourceType öеĳԱһһӦ
muxiaowei  20140724
******************************************************/
LIBCORE_API int core_set_alarm_push(unsigned login_id,int push_mask);

/******************************************************
LIBCORE_API int core_get_alarm_push(int * push_mask)
ûȡӿ
int push_mask bitλӵ͵λeEventSourceType öеĳԱһһӦ
muxiaowei  20140724
******************************************************/
LIBCORE_API int core_get_alarm_push(int* push_mask);


/******************mode************************/

LIBCORE_API const sys_mode_t * core_get_support_mode(int *num);
LIBCORE_API int core_sys_set_mode_id(unsigned login_id,int mode_id);
LIBCORE_API int core_sys_get_mode_id(int *mode_id);

LIBCORE_API int core_write_vmode(int channel, int vi_size);
LIBCORE_API int core_read_vmode(int channel, int *vi_size);
LIBCORE_API int core_set_aux_stream_rec(int enable);

typedef enum
{
	PR_MODE_MASTER=1,//豸
	PR_MODE_SLAVE = 2,//豸
}pr_work_mode;

typedef enum
{
	work_mode_idle = 0,
	park_ipc_device = 1,  //λ
	in_out_device = 2,	      //
} device_work_mode;  //ļҪ

typedef struct led_line_content_config_s
{
	int show_type;
	char show_edit[64];
	int align_type;
	int show_style;
	int effect_speed;
	int effect_period;
	char text_color[32];
	char bk_color[32];
	int reserve[8];
}led_line_content_config_t;

typedef struct led_line_config_s
{
	led_line_content_config_t busy_config;
	led_line_content_config_t free_config;
}led_line_config_t;

typedef struct pr_ledcfg_s
{
	int ch;
	int enable;//ʹ
	char brand[64];//LEDƷ
	int led_link;//ͨŷʽ
	int led_addr_bit;//ַλ
	int led_baudrate;//
	char led_ip[32];//IPַ
	int led_port;//˿
	int led_w;//LED
	int led_h;//LED
	unsigned int line_num;
	led_line_config_t line_config[8];
}pr_ledcfg_t;

//ϵͳ-VIPѡ
typedef struct assist_viptip_s
{
	int enable;			// ǷVIPʾ
	int viptip_cfg;		//VIPʾ(λȡ)
	int viptip_day;		//ǰ
	int reserved[4];
}assist_viptip_t;
//ϵͳ-ӡСƱ

//ϵͳ-
typedef struct assist_audio_s
{
	int  start_time;	//ʱοʼʱ
	int  end_time;		//ʱνʱ
	int  enable;		//Ƿ 0 1ñز 2LED
	int  volume;		//
	int  audio_open; 	//բͣ0ʾԶ
	char open_edit[64];	//բԶ
	int  audio_cfg;		//ѡ(λȡ)
	int  speed;			//
	int  speaker;		//Ա	
	int reserved[4];
}assist_audio_t;

typedef struct audio_config_t
{
	int ch;
	unsigned int period_num;
	assist_audio_t period_cfg[8];
}audio_config_t;

//Զբѡ
typedef struct tmp_authority_left_carport_config_s
{
	unsigned char enable;
	unsigned int left_carport_num;//ڴֵֹ
}tmp_authority_left_carport_config_t;

typedef struct tmp_authority_first_type_car_forbid_s
{
	unsigned char enable;
}tmp_authority_first_type_car_forbid_t;

typedef struct tmp_authority_second_type_car_forbid_s
{
	unsigned char enable;
}tmp_authority_second_type_car_forbid_t;

typedef struct tmp_authority_third_type_car_forbid_s
{
	unsigned char enable;
}tmp_authority_third_type_car_forbid_t;

typedef struct tmp_authority_config_s
{
	tmp_authority_left_carport_config_s left_carport;
	tmp_authority_first_type_car_forbid_t first_type_car;
	tmp_authority_second_type_car_forbid_t second_type_car;
	tmp_authority_third_type_car_forbid_t third_type_car;
}tmp_authority_config_t;

typedef struct blacklist_authority_config_s
{
	unsigned char enable;
}blacklist_authority_config_t;

typedef struct exit_not_match_authority_config_s
{
	unsigned char enable;
}exit_not_match_authority_config_t;

typedef struct auto_channel_period_config_s
{
	int start_time;
	int end_time;
	tmp_authority_config_t tmp_authority;
	blacklist_authority_config_t blacklist_authority;
	exit_not_match_authority_config_t exit_not_match_authority;
}auto_channel_period_config_t;
typedef struct auto_channel_config_s
{
	int ch;
	unsigned int period_num;
	auto_channel_period_config_t period[8];
}auto_channel_config_t;

LIBCORE_API	int core_pr_set_config(int channel, pr_config_t  config);
LIBCORE_API	int core_pr_get_config(int channel, pr_config_t * config); 
LIBCORE_API	int core_pr_set_ledcfg(pr_ledcfg_t  config);
LIBCORE_API	int core_pr_get_ledcfg(pr_ledcfg_t *config); 
LIBCORE_API	int core_pr_set_audio_cfg(audio_config_t config); 
LIBCORE_API	int core_pr_get_audio_cfg(audio_config_t *config); 
LIBCORE_API	int core_pr_set_colorcfg(int channel, pr_color_cfg_t  config);
LIBCORE_API	int core_pr_get_colorcfg(int channel, pr_color_cfg_t* config); 
LIBCORE_API	int core_pr_set_gatecfg(auto_channel_config_t  config);
LIBCORE_API	int core_pr_get_gatecfg(auto_channel_config_t *config); 

LIBCORE_API	int core_pr_set_work_mode(pr_work_mode work_moed); 
LIBCORE_API	int core_pr_get_work_mode(pr_work_mode *work_moed); 
LIBCORE_API	int core_pr_set_lever_cfg(int leverCfg); 
LIBCORE_API	int core_pr_get_lever_cfg(int *leverCfg); 
LIBCORE_API	int core_pr_set_viptip_cfg(assist_viptip_t config); 
LIBCORE_API	int core_pr_get_viptip_cfg(assist_viptip_t *config); 

#define company_name_len 64
LIBCORE_API int core_get_company_name(char* name);	
LIBCORE_API int core_set_company_name(char* name);
#define super_user_pwd_len 32
LIBCORE_API int core_get_super_user_pwd(char* pwd);
LIBCORE_API int core_set_super_user_pwd(char* pwd);

LIBCORE_API	int core_set_login_cfg(int autoLogin); 
LIBCORE_API	int core_get_login_cfg(int *autoLogin); 
typedef struct http_config_s
{
	int enable;			// Ƿhttp
	int http_monopolize;	//Ƿʹöռģʽ 
	char server[64];		// httpַ
	int  port;				// http˿.
	int ssl_enable;		// ǷSSL
	int ssl_potr;			// SSLʱ˿
	int ssl_time;			// SSLʱʱ λ
	int register_enable;      //Ƿ豸ע
 	char server_addr[128];		// עַ
 	int push_enable;      //Ƿ
 	char push_addr[128];		// ͵ַ
 	int send_pic_enable;		//ǷͼƬ
	int trigger_enable;		// Ƿ˿ڷϢ
 	char trigger_addr[128];		// ˿Ϣ͵ַ
	int reserve[64];		// 
}http_config_t;

LIBCORE_API int core_set_http_cfg(int ch_indx, http_config_t * config);
LIBCORE_API int core_get_http_cfg(int ch_indx, http_config_t * config);

LIBCORE_API int core_get_park_area_plate(int park_area_id, char *plate_string);


typedef enum
{
	RES_SIZE_NOT_CARE = 0,		//άԭߴ粻
	RES_SIZE_CIF 		= (1 << 1),		//352*288 	0x02
	RES_SIZE_HD1		= (1 << 2),		//704*288 	0x04
	RES_SIZE_D1			= (1 << 3),		//704*576 	0x08
	RES_SIZE_720P		= (1 << 4),		//1280*720	0x10
	RES_SIZE_1080P		= (1 << 5),		//1920*1088	0x20
	RES_SIZE_SXGA		= (1 << 6),		//1280*1024	0x40
	RES_SIZE_VGA		= (1 << 7),		//640*480	0x80
	RES_SIZE_QVGA		= (1 << 8),		//320*240	0x100
	RES_SIZE_QQVGA		= (1 << 9),		//176*128	0x200
	RES_SIZE_1280x960 	= (1 << 10),	//1280*960	0x400
	RES_SIZE_960P 		= ENC_SIZE_1280x960,		
	RES_SIZE_960H   	= (1 << 11),   //928x576	0x800
	RES_SIZE_AUTO   	= (1 << 12),   //ipc Զʶߴ 0x1000
	RES_SIZE_3M 		= (1 << 13),//2304*1296,3521/3531ָ֧óߴ 0x2000
	RES_SIZE_3stdM 		= (1 << 14), //2048*1536	0x4000
	RES_SIZE_5M 		= (1 << 15), //2592*1920	0x8000
	RES_SIZE_5stdM 		= (1 << 16), //2560*1920	0x10000
	RES_SIZE_4M         = (1 << 17),  //2304*1728	0x20000
	RES_SIZE_1920H      = (1 << 18),  //960*1080	0x40000
	RES_SIZE_3M_HK		= (1 << 19),  //1920*1536   0x80000
}resolution_type;

typedef struct pr_ipc_cfg_s
{
	int video_enable;					//ʵʱǷ 
	int space_num;						//λ
	int spaceId[16];					//λ
	int reserved[32];
}pr_ipc_cfg_t ;
LIBCORE_API int core_get_park_area_config(int channel, pr_ipc_cfg_t * config);
LIBCORE_API int core_set_park_area_config(int channel, pr_ipc_cfg_t * config);

LIBCORE_API	int core_set_device_work_mode(device_work_mode work_mode,int ch); 
LIBCORE_API	int core_get_device_work_mode(device_work_mode *work_mode,int *ch); 


#endif
