#ifndef _HD_API_DEF_H_
#define _HD_API_DEF_H_

#include <sys/time.h>
#include <sys/types.h>
#include <errno.h>



#define MAX_DISK_PARTITIONS 14	//°汾

typedef enum
{
	DISK_STAT_ERROR	 	= -1,		//
	DISK_STAT_NORMAL 	= 0,		//
	DISK_STAT_WRITE 	= 1,		//д
	DISK_STAT_FORMAT 	= 2,		//ڸʽ
}disk_state_e;

typedef struct search_file_list_node_s
{
	time_t start_time;
	time_t end_time;

	int channel;
	int record_type;
	size_t file_size;
	char file_path_name[128];
	
	struct search_file_list_node_s * previous_node;
	struct search_file_list_node_s * next_node;

	int node_status;
	int need_merge;		//ǷΪδɺϲ¼
}search_file_list_node_t;

typedef struct search_file_list_head_s
{
	int list_node_count;
	struct search_file_list_node_s * active_node;
	
	struct search_file_list_node_s * head_node;
	struct search_file_list_node_s * tail_node;
	struct search_file_list_node_s * newest_node;
}search_file_list_head_t;

typedef struct
{
	char dev_name[32];
	int bus_num;
	disk_state_e status;
	int part_num;
	unsigned long disk_space_MB;
	unsigned long part_space_MB[MAX_DISK_PARTITIONS];
	unsigned long valid_part_space_MB[MAX_DISK_PARTITIONS];
	char mount_point[MAX_DISK_PARTITIONS][64];
}disk_into_t;

typedef enum
{
	DISK_EVENT_REC_FULL = 0x01,		//¼ˣҪл¼µķ
	DISK_EVENT_RD_ONLY = 0x02,		//зֻˣҪ¹ط
	DISK_EVENT_NEW_PART_ADD = 0x04, //µķûй
	DISK_EVENT_ALL_DISK_FULL = 0x08, //з¼
	DISK_EVENT_FS_ERR = 0x10,	//ļϵͳ쳣Ҫ޸쳣
	DISK_EVENT_REC_WR_ERR = 0x20,	//¼д쳣
	DISK_EVENT_ALL_DISK_ERR = 0x40,	//Ӳ쳣޷¼Ҫ󿴿ָܻҪʽ

	//ʧܲһɾй©£й©һᵼ·ʧܣ־й©
	//Ϊ쳣Ҳûа취
	DISK_EVENT_FD_OVERFLOW = 0x80,
	DISK_EVENT_WRITE_TEST_FAILED = 0x100,
}hsx_disk_event;

typedef enum
{
	SDK_LOCAL_PB = 0x01,
	SDK_NET_PB_READ = 0x02,
}hd_list_usr_type;

//¼ļ洢
typedef enum
{
	REC_FSTR_MAIN        = 0x1,	//
	REC_FSTR_AUX         = 0x2,	//
}rec_fstr_type;

typedef struct 
{
	int ch_idx;  //ͨ
	int video_type; //¼
	char fname[128]; //ļ
	rec_fstr_type fstr_type;//Ҫ
	size_t name_len;//ļ
	int resevred[8];
}rec_fname_s;

typedef struct 
{
	int ch_idx;//ͨ
	int rec_type;//¼
	int need_uncomplete;//ǷҪ¼ļ
	time_t day;//һ¼ļ
	rec_fstr_type fstr_type;//Ҫ
	int resevred[8];
}rec_search_s;

#endif

