#ifndef _UTILITY_API_H_
#define _UTILITY_API_H_

#include "utility_api_def.h"

#ifdef __cplusplus
extern "C" {
#endif

int	utility_system(const char *cmd);
int	utility_system_pms(const char *cmd);

hsx_fs_type utility_get_fs_type();

//ӴӡϢӡutilityĵǰ汾Ϣ
void utility_show_version();


//=====================================================================================
/*
*func_name: fq_create
*function:	ûʼõĽӿڣһӦfq_listfq_listѾڣֱӷأڴ
*			ע:fq_list ͨch streamʶ
*params: fq_info-->fq_listĽṹ壬ͬfq_listchstream
*					ÿfq_listbufС֡
*return: -1 error; 0 success
*/
int fq_create(fq_queue_info_t *fq_info);


//================================򿪹ر֡================================
/*
*func_name: fq_open
*function:	ûһӦfq_listһgetput
*params: who-->û fq_stream-->ȡfq_listĽṹ
*return: -1 error; handle success
*/
int fq_open(const char *who, fq_queue_stream_t *fq_stream);

/*
*func_name: fq_close
*function:	رһfq_open򿪵ľ
*params: handle-->һ˵ľ
*return: -1 error 0 success
*/
int fq_close(int handle);

//=================================ȡͷ֡=================================
/*
*func_name: fq_get_frame
*function:	ڶӦfq_listжȡһ֡
*params: handle-->һ˵ľ 
*return: NULL error not NULL(get) success 
*/
frame_slice_info_t *fq_get_frame(int handle);

/*
*func_name: fq_release_frame
*function:	fq_get_frameһ֡ͷţͷžͲܽһεget
*params: handle-->һ˵ľ frame_info-->get֡
*return: -1 error 0 success 
*/
int fq_release_frame(int handle, frame_slice_info_t *slice_head);


//===============================½֡ѹ================================
/*
*func_name: fq_new_frame
*function:	memҵӦķڴ
*params: who-->Ҫnew frameû length-->Ҫݳ
*					ע:newĲֻlengthĳȣlengthǰ滹һsizeof(frame_slice_info_t)ĳ
*					100ֽڵԤ
*return: NULL error not NULL success
*/
frame_slice_info_t *fq_new_frame(const char *who, int length);

/*
*func_name: fq_put_frame
*function:	ȡ֡ݷŵfq_listУݿvencģipc
*params: handle-->һ˵ľ frame_info-->Ϣ 
* 		need_copy-->netclientзݵʱֱӸ0libchipиݵʱ1ΪõĶhisiⲿռ䣬Ҫ
*					ע:ֻǴָ룬ûнvencлȡֱӷŵfq_listУӦfq_list
*					5ûһûgetݽпfq_listСһο
*return: -1 error 0 success
*/
int fq_put_frame(int handle, frame_slice_info_t *slice_head, int need_copy);



//===============================ͷnewframe================================
/*
*func_name: fq_delete_frame
*function:	memзڴΪ֡𻵶ûõֱӻmem
*params: frame_slice-->Ҫdeleteһ֡buf
*return: -1 error 0 success
*/
int fq_delete_frame(frame_slice_info_t *frame_slice);


//===============================ȡûҪѯfq״̬================================
/*
*func_name: fq_get_list_status
*function:	handleҵӦfqȻȡfq״̬fq(Ҫ֡)
*params: handle-->ͨfqȡhandlefq_status ȡfq_listϢĽṹָ 
*return: -1 error 0 success
*/
int fq_get_list_status(int handle, fq_list_status_t *fq_status);



//resolution transfor

/*
*resolution_str2enc
*ִʾresolutionתöenc_size_e ִжֱʣصöٻὫÿһֱλһ
*return : enc_size_e mask
*/
int 	resolution_str2enc(const char * str);


/*
*resolution_str2size
*ִʾresolutionתɿߣִжֱʣֻתһ
*return : 0 ɹ -1ʧ
*/
int 			resolution_str2size(const char * str, int * width, int* height);

/*
*resolution_size2enc
*߱ʾresolutionתenc_size_e
*return : enc_size_e
*/
enc_size_e	resolution_size2enc(int width, int height);

/*
*resolution_enc2size
*enc_size_eʾresolutionתɿ
*return : 0ɹ-1ʧ
*/
int			resolution_enc2size(enc_size_e enc_size, video_stand_e std, int *width, int *height);

#ifdef __cplusplus
}
#endif

#endif	//#ifndef _UTILITY_API_H_
