#ifndef _UTILITY_API_DEF_H_
#define _UTILITY_API_DEF_H_

#include <time.h>
#include <sys/time.h>
//#include "sdk_api_def.h"

typedef enum
{
	FS_USE_MNT_MTD,		///mnt/mtd/
	FS_USE_CONFIG,		///config/
}hsx_fs_type;

typedef enum
{
	FQ_STREAM_MAIN,
	FQ_STREAM_AUX,
	FQ_STREAM_AUDIO,
	
	FQ_STREAM_AUX1,
	FQ_STREAM_AUX2,
	FQ_STREAM_AUX3,
}fq_stream_type_e;

typedef struct fq_queue_stream_s
{
	int 				channel;
	int				 	stream;

	int 				reserved[4];
}__attribute__((packed)) fq_queue_stream_t;

typedef struct fq_queue_info_s
{	
	fq_queue_stream_t   fq_queue_stream;
	int 				max_buf_size;
	int 				max_frame_count;
	
	int 				reserved[8];
}__attribute__((packed)) fq_queue_info_t;

typedef struct frame_slice_info_s
{
	int 			channel;
	int				frame_type;
	int 			stream_type;
	int			 	encode_type;
	unsigned int 	frame_no;
	int 			width;
	int 			height;
	struct timeval 	timestamp;
	size_t 			frame_size;
	//the above elements only be filled in the head node

	int			 	slice_index;//the index of slice node
	char 			*slice_buf;//every slice node start addr, like buf1
	int 			slice_buf_size;//every slice node malloc size
	
	int 	slice_start_offset;//valid data offset relative to slice_buf
	unsigned int 	slice_data_length;//valid data length

	struct frame_slice_info_s 	*pre;
	struct frame_slice_info_s 	*next;	
	int	  list_cnt;//the number of nodes in the list
}frame_slice_info_t;

typedef struct fq_list_status_s
{
	int list_depth;
	
	int newest_frame_index;
	int cur_rd_index;
	int list_max_frame_num;
	int cur_list_frame_num;
	int list_max_buf_len;
	int cur_list_frame_len;
	int reserved[8];
}fq_list_status_t;


//////////////////////////////////////////////////
//resolution transfor
typedef enum
{
	ENC_SIZE_NOT_CARE = 0,		//άԭߴ粻
	ENC_SIZE_CIF 		= (1 << 1),		//352*288 	0x02
	ENC_SIZE_HD1		= (1 << 2),		//704*288 	0x04
	ENC_SIZE_D1			= (1 << 3),		//704*576 	0x08
	ENC_SIZE_720P		= (1 << 4),		//1280*720	0x10
	ENC_SIZE_1080P		= (1 << 5),		//1920*1088	0x20
	ENC_SIZE_SXGA		= (1 << 6),		//1280*1024	0x40
	ENC_SIZE_VGA		= (1 << 7),		//640*480	0x80
	ENC_SIZE_QVGA		= (1 << 8),		//320*240	0x100
	ENC_SIZE_QQVGA		= (1 << 9),		//176*128	0x200
	ENC_SIZE_1280x960 	= (1 << 10),	//1280*960	0x400
	ENC_SIZE_960P 		= ENC_SIZE_1280x960,		
	ENC_SIZE_960H   	= (1 << 11),   //928x576	0x800
	ENC_SIZE_AUTO   	= (1 << 12),   //ipc Զʶߴ 0x1000
	ENC_SIZE_3M 		= (1 << 13),//2304*1296,3521/3531ָ֧óߴ 0x2000
	ENC_SIZE_3stdM 		= (1 << 14), //2048*1536	0x4000
	ENC_SIZE_5M 		= (1 << 15), //2592*1920	0x8000
	ENC_SIZE_5stdM 		= (1 << 16), //2560*1920	0x10000
	ENC_SIZE_4M         = (1 << 17),  //2304*1728	0x20000
	ENC_SIZE_1920H      = (1 << 18),  //960*1080	0x40000
}enc_size_e;

typedef enum 
{
	VIDEO_STD_UNKONW      = 0x00000000,	//Ƶźŵʱȡźʽ
	VIDEO_STD_NTSC        = 0x00000001,
	VIDEO_STD_PAL         = 0x00000002,
	VIDEO_STD_SECAM       = 0x00000004,
}video_stand_e;  


#define FLOAT_PERCENT_RESOLUTION 	0.08
#define FLOAT_PERCENT_RESOLUTION_4M 	0.13
#define RESOLUTION_1080P_STD		1920*1080
#define RESOLUTION_3M_STD			3*1024*1024
#define RESOLUTION_4M_STD			4*1024*1024
#define RESOLUTION_5M_STD			5*1024*1024


#endif
