#ifndef P2P_API_H
#define P2P_API_H

#include <sys/types.h>

/*
*VERSION changelog

*V2.0.0(20160603)
*MODIFY:
(1) use udt instead of udp
(2) separate partner from udp , use partner_connect_request instead of it

*V1.7.2(20150422)
*MODIFY:use new ppyum dn replace dddns

*V1.7.1(20150421)
*MODIFY:remove big buf from stack, move to heap
*V1.7.0(20150131)
*ADD:default server ip
*ADD:dns resolv in background
*V1.6.6(20150128)
*ADD: device type input from ddns client
*V1.6.5(20141218)
FIX: udp session first packet send failed
*V1.6.4(20141106)
REMOVE: remove bind session , not use it from now
*V1.6.4
MODIFY: use smartmeye domain name replace one list server
*V1.6.3
ADD: excute cmd from client
*V1.6.2
FIX: get p2p id from share mem
FIX: ADD LOSTED MSG PROCESS P2P_MSG_SESSION_TARGET_UNREACHABLE
*V1.6.1
ADD: WIFI IP ADDR
ADD: RECOVER BIND SESSION PROCESS
ADD: KLW DEVICE
*V1.6.0
*ADD: core session only get server list from serverlist server 
*REMOVE: remove bind session 
*V1.5.5
*ADD: get p2p running status
*ADD: get server list
*V1.5.4
* ADD: add P2P_MSG_SESSION_TARGET_UNREACHABLE msg
*V1.5.3
* ADD: memblock, for reduce little mem block
*V1.5.2
* ADD: restrict only one client can use udp partner
*V1.5.1
*ADD: p2p provide new interface for  get domain name
*ADD: p2p add get domain name function form ddns share mem
*V1.5.0
*FIX: sometime session will dead lock
*FIX: add udp flowcontrol
*V1.2.0
*add udp support
*V1.1.2
*add support for p2p tools
*V1.0.2
*add A node sync send partner info
*V1.0.1
* add bind dectect and bad node report
* 
*/
#define	P2P_VERSION		"2.0.0"

typedef char gk_char;
typedef unsigned char gk_uchar;
typedef int gk_int32;
typedef short gk_int16;
typedef unsigned short gk_uint16;
typedef unsigned int gk_uint32;
typedef long long gk_int64;
typedef unsigned long long gk_uint64;

typedef int gk_bool;


#define GK_FALSE	0
#define GK_TRUE		1
#define GK_ERR_A	-2

typedef enum{
	P2P_DATA_BEGIN = 0,	
	P2P_DATA_CMD,
	P2P_DATA_MEDIA,
	P2P_DATA_SYS,
	P2P_DATA_END,	
	
}P2P_DATA_TYPE_E;

typedef enum {
	P2P_PROTOCOL_UNKNOW = 0,
	P2P_PROTOCOL_HSX,
	P2P_PROTOCOL_LANGTAO,
	P2P_PROTOCOL_JL,
}PARSE_PROTOCOL_E;

typedef enum{
	P2P_MSG_ID_BEGIN,
		
	//sys msg: node and server	
	P2P_MSG_ID_SYS = 1000, 
	P2P_MSG_ID_HELLO,
	P2P_MSG_ID_HELLO_REPLY,
	P2P_MSG_ID_SYNC,
	P2P_MSG_ID_SYNC_REPLY,
	P2P_MSG_ID_TYPE_CHECK,
	P2P_MSG_ID_TYPE_REPLY,
	P2P_MSG_GET_PROXY,
	P2P_MSG_GET_PROXY_REPLY,
	P2P_MSG_GET_NODE_INFO,
	P2P_MSG_GET_NODE_INFO_REPLY,
	P2P_MSG_BAD_NODE_REPORT,
	P2P_MSG_UDP_CONNECT_REQUEST,
	P2P_MSG_UDP_CONNECT_REPLY,
	P2P_MSG_CONNECT_REPORT,
	P2P_MSG_GET_SERVER_LIST,
	P2P_MSG_GET_SERVER_REGISTER,
	P2P_MSG_GET_SERVER_LIST_ALL,	//ȡбϸϢ
	P2P_MSG_TCP_PARTNER_CONNECT_REQUEST,
	P2P_MSG_TCP_PARTNER_CONNECT_REPLY,


	//session msg:  node and node
	P2P_MSG_ID_SESSION = 2000, 
	P2P_MSG_ID_BIND_REQ,
	P2P_MSG_ID_BIND_REPLY,	//not use after 1.6.0
	P2P_MSG_SESSION_DISCONNECT,
	P2P_MSG_SESSION_TARGET_UNREACHABLE,	
	P2P_MSG_ID_UDT_BIND_REQ,
	P2P_MSG_ID_UDT_BIND_REPLY,
	
	//user msg: user data 
	P2P_MSG_ID_USER = 3000, //user, need redirect, just for user
	P2P_MSG_USER_DISCONNECT,	//ӶϿ ûҪͷŶӦp2pʹõԴ
	P2P_MSG_USER_BINDLOST,		//󶨶ʧ ûҪͷp2pʹõԴ
	P2P_MSG_USER_TARGET_UNREACHABLE,		
	
	P2P_MSG_ID_USER_SESSION = 3500, //user session, process by p2p, not to user, need redirect
	P2P_MSG_USER_HEARTBEAT,
	P2P_MSG_SESSION_GET_STATUS,
	P2P_MSG_UDP_HELLO,
	P2P_MSG_UDP_ROUTE_HEARTBEAT,
	P2P_MSG_UDP_ROUTE_DELAY_TEST_RESERVE,
	P2P_MSG_CONNECTION_TEST,
	P2P_MSG_UDP_ACK,
	P2P_MSG_SYS_CMD,
	P2P_MSG_UDP_HELLO_REPLY,
	P2P_MSG_ROUTE_HEARTBEAT,
	P2P_MSG_PARTNER_ROUTE_HEARTBEAT,
	
	//private: msg handle inside node, not go outside
	P2P_MSG_ID_PRIVATE = 4000,
	P2P_MSG_SOCKET_BROKEN,
	P2P_MSG_BIND_SUCESS,
	P2P_MSG_BIND_LOST,
	P2P_MSG_UDP_DISCONNECT,


	//event
	P2P_MSG_ID_EVENT = 5000, //event
	P2P_MSG_ID_EVENT_DISCONNECT, 
	
	P2P_MSG_ID_END = 65535,
	}P2P_MSD_ID_E;


typedef enum{
	p2p_connect_unknow = 0,
	p2p_connect_direct,
	p2p_connect_undirect,
	}p2p_connect_type_e;


typedef struct node_uid_s{
	char uid[16];
	}__attribute((aligned (4))) node_uid_t;

#ifdef __cplusplus 
extern "C" { 
#endif 

typedef  gk_bool (*p2p_data_cbf)(node_uid_t* from, gk_uint32 port, const char *user, size_t user_len, char * private_date, gk_int32 protocol);
typedef  gk_bool (*p2p_event_cbf)(gk_uint32 event_type,node_uid_t* about,  gk_int32 data1, gk_int32 data2);

typedef struct p2p_config_s{
	char domain_name[32];
	gk_int32 p2p_port;
	gk_int32 p2p_enable;
	gk_int32 reserve1;
	gk_int32 reserve2;
	gk_int32 debug_level;
}p2p_config_t;

typedef enum{
	SYNC_UNKNOW = -1,
	SYNC_DNS_FAILED,
	SYNC_DNS_OK,
	SYNC_HELLO_FAILED,
	SYNC_HELLO_OK,
	SYNC_FAILED,
	SYNC_OK,
	SYNC_SERVERLIST_FAILED,
	}P2P_SYNC_RESULT_E;

typedef struct p2p_status_s{
	char 		p2p_id[32];	//p2p id
	node_uid_t 	p2p_uid; // p2p uid
	gk_int32 		p2p_port; //p2p port
	char 		server[32]; // server domain name
	P2P_SYNC_RESULT_E	sync_result; //last sync result
	time_t		sync_interval; // sync interval
	time_t		sync_time; // last sync time
	gk_int32		node_type; // node type
	gk_int32		bind_cnt; // bind node count
	gk_int32		bind_status; // bind status
	gk_int32		reserve[32];
	
}p2p_status_t;

void 		p2p_show_version();
gk_int32 p2p_start(const char* key, p2p_config_t * config);	
gk_int32 p2p_send(node_uid_t* to, gk_uint32 port, const char *user, size_t user_len, char * private_date, size_t private_len, gk_int32 flag);	
gk_int32 p2p_stop();
gk_int32 p2p_disconnect(node_uid_t* to);
gk_int32 p2p_recv(node_uid_t* from, gk_uint32* port, const char *user, size_t* user_len, gk_int32* protocol);
gk_int32 p2p_recv_event(gk_uint32* event_type,node_uid_t* about,  int* data1, int* data2);

p2p_connect_type_e 	p2p_get_connect_type(node_uid_t* node);
int 					p2p_get_connect_speed(node_uid_t* node);
gk_int32 	p2p_get_domain_name(char * domain, size_t domain_len);
gk_int32 p2p_get_running_status(p2p_status_t * status);

#ifdef __cplusplus 
} 
#endif 

#endif
