/*
   xml lib api 
*/


#ifndef _XML_API_H_
#define _XML_API_H_


#ifdef TIXML_USE_STL
	#include <iostream>
	#include <sstream>
	using namespace std;
#else
	#include <stdio.h>
#endif

#if defined( WIN32 ) && defined( TUNE )
	#include <crtdbg.h>
	_CrtMemState startMemState;
	_CrtMemState endMemState;
#endif



//#include "tinyxml.h"

#define MAX_NODE_LEVEL	10
#define MAX_NODE_NAME_LENGTH	64

extern "C"{
	//same to c open, if error , return -1, or return file handle bigger than zero
	FILE * xml_file_open(const char * filename);

	//if success, return 0, or failed
	int xml_file_read(FILE * fd,char * buf,size_t buf_len,char* path, int get_attr, const char* attr_name);
	//
	int xml_file_write(FILE * fd,void * buf,size_t buf_len,char* path, int get_attr,const char* attr_name);
	//
	int xml_file_close(FILE * fd);

	int xml_file_save(FILE * fd);


	FILE * xml_file_bybuffer(char* xml_buffer);
	// write a node
	int xml_file_write_new(FILE * fd,void * buf,size_t buf_len,const char* path, int set_attr,const char* attr_name);
	// export current xml tree to buffer
	//int xml_file_export(int fd, char* buffer);
	int xml_file_export(FILE * fd, char* buffer, int len);
};

#endif

